import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_angulo extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = -8951988303802222212L;
    Color c;
    boolean dcha=false;
    double alfa, beta, alfag, betag, tet1, tet2, tet21, w, abs00, abs0, abs1, abs2;
    Objetos_bezicirc ov1; 
    Objetos_linea l1; 
    Objetos_punto p1, p2;
    int linea_old=0,mialfa,mibeta;

 
    Objetos_angulo(Objetos_bezicirc miOval, Objetos_linea miLinea, Objetos_list p)
    {
 	super(p);
	ov1=miOval;
	l1=miLinea;
	cj+=2;
	nombre="ang";
	p1=new Objetos_punto(ov1,l1,9,1,p);
	p2=new Objetos_punto(ov1,l1,9,2,p);
	select = 1;
    }


    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,4);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	Graphics2D g2 = (Graphics2D) g ;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	xd[0]=(ov1.xd[1]+ov1.xd[0])/2;
	yd[0]=(ov1.yd[1]+ov1.yd[0])/2;
	xc=xd[0];yc=yd[0];zc=0;
	xd[1]=p1.xd[0]; yd[1]=p1.yd[0];
	xd[2]=p2.xd[0]; yd[2]=p2.yd[0];
	xd[3]=ov1.xd[0]; yd[3]=ov1.yd[0];
	w=(double)ov1.w;

	tet1 = Math.atan2((yd[0]-yd[1]),(xd[1]-xd[0])) ; 
       	if(tet1<0)tet1+=2*pi;
	tet2 = Math.atan2((yd[0]-yd[2]),(xd[2]-xd[0])) ;
	if(tet2<0)tet2+=2*pi;
	if(tet2<tet1)tet2+=2*pi;
	tet21= tet2-tet1;

	alfa=Math.atan2(yd[0]-yd[1],xd[1]-xd[0]);
	beta=Math.atan2(yd[0]-yd[2],xd[2]-xd[0]);
	alfag=alfa*180/pi;if(alfag<0)alfag+=360;
	betag=beta*180/pi;if(betag<0)betag+=360;
	if(alfag>betag){abs1=alfag-betag;abs0=betag;}
	else {abs1=betag-alfag;abs0=alfag;}
	abs2=-360+abs1;
	Arc2D.Double arco1 = new Arc2D.Double(xd[3],yd[3],w,w,abs0,abs1,0);
	Arc2D.Double arco2 = new Arc2D.Double(xd[3],yd[3],w,w,abs0,abs2,0);
	if(forma[11+cj]==null)forma[11+cj]=(Shape)arco1;
	if(forma[12+cj]==null)forma[12+cj]=(Shape)arco2;
	forma[11+cj]=ov1.forma[11+cj];

	if(select!=0)
	    {
		if(Drawing.ggll==1){
		    forma[11+cj]=(Shape)arco1;
		    forma[12+cj]=(Shape)arco2;
		    dcha=true;
		}
		else {
		    forma[11+cj]=(Shape)arco2;
		    forma[12+cj]=(Shape)arco1;
		    dcha=false;
		}
		g2.setColor(Color.red);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		g2.draw(forma[11+cj]);
	    }

	if(select==0)
	    {
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		g.setColor(cl);
		g2.draw(forma[12+cj]);
		if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		g.setColor(cl);
	      	g2.draw(forma[11+cj]);
	    }

	rc=new Rectangle(xsel-5,ysel-5,11,11);
        if(g2.hit(rc,forma[11+cj],true) || g2.hit(rc,forma[12+cj],true)){ inters=true;}
	else inters=false;

	g.setColor(cl); 
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	
    }
    

    public void metapost(BufferedWriter out) 
    {
	float cr=0, cv=0, ca=0;
	c=cc;
	double xn0=xd[0]/(10*uesc);
	double xn1=xd[1]/(10*uesc);
	double xn2=xd[2]/(10*uesc);
	double yn0=118*Drawing.u-yd[0]/(10*uesc);
	double yn1=118*Drawing.u-yd[1]/(10*uesc);
	double yn2=118*Drawing.u-yd[2]/(10*uesc);
	double xx1 = 1.2*(xn1-xn0)+xn0;
	double yy1 = 1.2*(yn1-yn0)+yn0;
	double xx2 = 1.2*(xn2-xn0)+xn0;
	double yy2 = 1.2*(yn2-yn0)+yn0;
	double tt=tet1+tet21;
	if(tt > 2*pi)tt-=2*pi;
	if(refill==1)
	    {
		cr = (float)cc.getRed()/255f;
		cv = (float)cc.getGreen()/255f;
		ca = (float)cc.getBlue()/255f;
	    }
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	try 
	    {
	if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
	out.write ("loc:=("+rc+","+vc+","+ac+");\n");
	out.write ("pickup pencircle scaled "+thickness+";\n");
	out.write("path a, b, r, s;\n");
	out.write("r:=("+xn0+"u,"+yn0+"u)--("+xx1+"u,"+yy1+"u);\n");
	out.write("s:=("+xn0+"u,"+yn0+"u)--("+xx2+"u,"+yy2+"u);\n");
	out.write("a:= fullcircle scaled "+(w/(10*uesc))+"u shifted ("+xn0+"u,"+yn0+"u) rotatedaround(("+xn0+"u,"+yn0+"u),"+(180*tet1/pi)+") cutafter s cutbefore r;\n");
	    out.write(drw+" a withcolor loc ");
	    if(linea!=0 && (tt<tet1)){linea_old=linea;out.write(tipo_linea);linea=0;}
	    else out.write(";\n");
	    out.write("b:= fullcircle scaled "+(w/(10*uesc))+"u shifted ("+xn0+"u,"+yn0+"u) rotatedaround(("+xn0+"u,"+yn0+"u),"+(180*tt/pi)+") cutafter r cutbefore s;\n"); 
	       	out.write(drw+" b withcolor loc ");
	      	if(linea!=0)out.write(tipo_linea);
	       	else out.write(";\n");
		if(linea==0)linea=linea_old;
	    }
	
	catch (IOException e) { System.out.println("No he podido escribir...Consultar al autor.");}             
    }
    


    public void movepoint(int x,int y)
    {
	if(ijk==0)
	    {
		if(ov1.select==5 || ov1.select==3)ov1.x1 += x; 
		if(ov1.select==4 || ov1.select==2)ov1.x0 += x;
		if(ov1.select==5 || ov1.select==4)ov1.y1 += y;
		if(ov1.select==3 || ov1.select==2)ov1.y0 += y;
		if(ov1.x0<ov1.x1) { xmin = ov1.x0-1 ; xmax = ov1.x1+1 ; }
		else      { xmin = ov1.x1-1 ; xmax = ov1.x0+1 ; }
		if(ov1.y0<ov1.y1) { ymin = ov1.y0-1 ; ymax = ov1.y1+1 ; }
		else      { ymin = ov1.y1-1 ; ymax = ov1.y0+1 ; }
	    }
    }

    public boolean selectpoint(int x,int y)
    {
	double xx, yy;
	xx=(double)x; yy=(double)y;

	if((x-ov1.x0<5 && x-ov1.x0>-5 && y-ov1.y0<5 && y-ov1.y0>-5) || (xx-ov1.xd[0]<5. && xx-ov1.xd[0]>-5. && yy-ov1.yd[0]<5. && yy-ov1.yd[0]>-5.))
	    {
		select = 2;
		return(true);
	    }
	if((x-ov1.x1<5 && x-ov1.x1>-5 && y-ov1.y0<5 && y-ov1.y0>-5) || (xx-ov1.xd[3]<5. && xx-ov1.xd[3]>-5. && yy-ov1.yd[3]<5. && yy-ov1.yd[3]>-5.))
	    {
		select = 3;
		return(true);
	    }
	if((x-ov1.x0<5 && x-ov1.x0>-5 && y-ov1.y1<5 && y-ov1.y1>-5) || (xx-ov1.xd[2]<5. && xx-ov1.xd[2]>-5. && yy-ov1.yd[2]<5. && yy-ov1.yd[2]>-5.))
	    {
		select = 4;
		return(true);
	    }
	else if((x-ov1.x1<5 && x-ov1.x1>-5 && y-ov1.y1<5 && y-ov1.y1>-5) || (xx-ov1.xd[1]<5. && xx-ov1.xd[1]>-5. && yy-ov1.yd[1]<5. && yy-ov1.yd[1]>-5.))
	    {
		select = 5;
		return(true);
	    }
	return(false);
    }

    public void moveobj(int x,int y)
    {
	if(ijk==0)
	    {
		for(int i=0;i<4;i++)
		    {
			ov1.xd[i]+=(double)x;
			ov1.yd[i]+=(double)y; }
		ov1.x1 += x;
		ov1.x0 += x;
		ov1.y1 += y;
		ov1.y0 += y;
		if(ov1.x0<ov1.x1) { xmin = ov1.x0-2 ; xmax = ov1.x1+2 ; }
		else      { xmin = ov1.x1-2 ; xmax = ov1.x0+2 ; }
		if(ov1.y0<ov1.y1) { ymin = ov1.y0-2 ; ymax = ov1.y1+2 ; }
		else      { ymin = ov1.y1-2 ; ymax = ov1.y0+2 ; }
	    }
	if(ijk!=0) return;
    }
}
