import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_arcos extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = -3093007204306301052L;
    Color c;
    public int n, x0, y0, num, tipo ;
    public double R1, R2, tet1, tet2, tet21, tet3, dd, w, h,a,b,exi,emi,foc,xf1,yf1,xf2,yf2,r1,xxc,yyc,zzc;
    float xn0,xn1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
    float yn0,yn1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;
    Objetos_arcos(int xx0,int yy0,int t, Objetos_list p)
    {
	super(p);
	xd[0] = xd[1] = (double)xx0;
	x0 = xmin = xmax = xx0;
	yd[0] = yd[1] = (double)yy0;
	y0 = ymin = ymax = yy0;
	n = 2;
	tipo=t;
	select = 3;
	num=1;
	dd=-40;
    }

    Objetos_arcos(double xx0, double yy0, double xx1, double yy1, double ang, int t, Objetos_list p)
    {
 	super(p);
	xd[0]=xx0; yd[0]=yy0; xd[1]=xx1; yd[1]=yy1; tet21=ang*pi/180;
	select = 0;
	n=3;
	tipo=t;
	num=2;
	dd=-40;
    }

    Objetos_arcos(double xx0, double yy0, double xx1, double yy1, double ang, double d, Objetos_list p)
    {
 	super(p);
	xd[0]=xx0; yd[0]=yy0; xd[1]=xx1; yd[1]=yy1; tet21=ang*pi/180;
	select = 0;
	n=3;
        tipo=0;
	num=2;
	dd=-(40+d);
    }

    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,0.,6);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0;
	Graphics2D g2 = (Graphics2D) g ;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g2.setColor(c);
	if(num==1){
	Polygon p = new Polygon();
	for(int i=0;i<3;i++)p.addPoint(x0,y0);
	xxc=xd[0]; yyc=yd[0]; zzc=zd[0];
	xc=xxc; yc=yyc; zc=zzc;
	R1=Math.sqrt((xd[1]-xd[0])*(xd[1]-xd[0])+(yd[1]-yd[0])*(yd[1]-yd[0])); 
	R2=Math.sqrt((xd[2]-xd[0])*(xd[2]-xd[0])+(yd[2]-yd[0])*(yd[2]-yd[0]));
	tet1 = Math.atan2((yd[0]-yd[1]),(xd[1]-xd[0])) ; 
       	if(tet1<0)tet1+=2*pi;
	tet2 = Math.atan2((yd[0]-yd[2]),(xd[2]-xd[0])) ;
	if(tet2<0)tet2+=2*pi;
	if(tet2<tet1)tet2+=2*pi;
	tet21= tet2-tet1;
	}
	if(num==2){
	xc=xd[0]; yc=yd[0]; zc=zd[0];
	R1=Math.sqrt((xd[1]-xd[0])*(xd[1]-xd[0])+(yd[1]-yd[0])*(yd[1]-yd[0])); 
	tet1 = Math.atan2((yd[0]-yd[1]),(xd[1]-xd[0])) ; 
       	if(tet1<0)tet1+=2*pi;
	tet2 = tet21+tet1;
	xd[2]=(1.5*R1*Math.cos(tet2)+xd[0]);
	yd[2]=(-1.5*R1*Math.sin(tet2)+yd[0]);
	R2=Math.sqrt((xd[2]-xd[0])*(xd[2]-xd[0])+(yd[2]-yd[0])*(yd[2]-yd[0]));
	}
	xd[5]=xd[0]-R1;
	yd[5]=yd[0]-R1-((40+dd)*Drawing.u/2);
	w=2*Math.abs(xd[0]-xd[5]);
	h=2*Math.abs(yd[0]-yd[5]);

	xd[4]=(R1*Math.cos(tet2)+xd[0]);
	yd[4]=(-R1*Math.sin(tet2)+yd[0]);
	setminmax();
	r1=Math.abs((yd[5]-yd[0])/R1);
	GeneralPath lip = daForma(xd[5],xd[5]+w,xd[5],xd[5]+w,yd[5],yd[5]+h,yd[5]+h,yd[5]);
	forma[1] = (Shape)lip; 
	Arc2D.Double elarco = new Arc2D.Double(xd[5],yd[5],w,h,tet1*180/pi,tet21*180/pi,tipo);
	forma[11]=(Shape)elarco;
	if(select!=0)
	    {
		g.setColor(Color.red);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		for(int i = 0;i<n;i++)
		    {
			if(i==1)
			    {
				g2.drawLine((int)xd[0],(int)yd[0],(int)xd[1],(int)yd[1]);
				g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
				g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
			    }
			if(i==2)
			    {
	    if(Drawing.ggll==1){
				g2.setColor(Color.blue);
				g2.drawLine((int)xd[0],(int)yd[0],(int)xd[0],(int)(yd[0]+dd*Drawing.u));
				g2.fillRect((int)xd[0]-1,(int)(yd[0]+dd*Drawing.u)-1,3,3);
				g2.draw(new Arc2D.Double(xd[5],yd[0]-R1,w,w,tet1*180/pi,tet21*180/pi,tipo));
	    }
				g2.setColor(Color.red);
				g2.drawLine((int)xd[0],(int)yd[0],(int)xd[2],(int)yd[2]);
				g.fillRect((int)xd[2]-1,(int)yd[2]-1,3,3);
   Drawing.src32.setText("a1="+(float)((int)(tet1*1800/pi+.5))/10);
   Drawing.src33.setText("a2="+(float)((int)(tet21*1800/pi+.5))/10);
				g2.draw(forma[11]);
			    }
		    }
	    }

	else if(select==0)
	    {
		if(putarr == true)
		    {
		g.setColor(Color.blue);
		if((numarr/10)%10 == 1 && numarr%10 != 2) g.fillRect((int)(xd[4]-1),(int)(yd[4]-1),3,3);
		if(numarr%10 == 2) g.fillRect((int)(xd[1]-1),(int)(yd[1]-1),3,3);
		if((numarr/10)%10 == 2) 
		    {
			g.fillRect((int)(xd[4]-1),(int)(yd[4]-1),3,3);
			g.fillRect((int)(xd[1]-1),(int)(yd[1]-1),3,3);
		    }
		    }
		stroke = new BasicStroke(thickness);
		if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		if(refill==1 && tipo==2){
		g2.setColor(c);
		g2.fill(forma[11]);
		}
		g.setColor(cl);
	      	g2.draw(forma[11]);
	    }

	rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
        if(g2.hit(rc,forma[11],true)) inters=true;
	else inters=false;
	g.setColor(cl); 
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	
    }
 
    public void metapost (BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	if(refill==1)
	    {
		cr = (float)cc.getRed()/255f;
		cv = (float)cc.getGreen()/255f;
		ca = (float)cc.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
	try 
	    {
		if(putarr == true)
		    {
			if(miArrow0 != "")out.write(miArrow0);
			if(miArrow1 != "")out.write(miArrow1);
			if(miArrow2 != "")out.write(miArrow2);
			if(miArrow3 != "")out.write(miArrow3);
		    }
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		out.write("pickup pencircle scaled "+thickness+";\npath a,r,s;\na:=");

	double xn0=(xd[0]/(10*uesc));
	double xn1=(xd[1]/(10*uesc));
	double xn2=(xd[2]/(10*uesc));
	double xn5=(xd[5]/(10*uesc));
	double yn0=(118*Drawing.u-yd[0]/(10*uesc));
	double yn1=(118*Drawing.u-yd[1]/(10*uesc));
	double yn2=(118*Drawing.u-yd[2]/(10*uesc));
	double yn5=(118*Drawing.u-yd[5]/(10*uesc));
	double dist1=(Math.sqrt((xn1-xn0)*(xn1-xn0)+(yn1-yn0)*(yn1-yn0)));
	double dist2=(Math.sqrt((xn2-xn0)*(xn2-xn0)+(yn2-yn0)*(yn2-yn0)));
	if(dist2*1.19 < dist1 || dist2 < dist1){xn2=xn0+1.2*dist1*(xn2-xn0)/dist2;yn2=yn0+1.2*dist1*(yn2-yn0)/dist2;}
	float xx0=(float)(xd[5]/uesc), xx1=(float)((xd[5]+w)/uesc), xx2=(float)(xd[5]/uesc), xx3=(float)((xd[5]+w)/uesc), yy0=(float)(yd[5]/uesc), yy1=(float)((yd[5]+h)/uesc), yy2=(float)((yd[5]+h)/uesc), yy3=(float)(yd[5]/uesc);
	float x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
	float y0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float xh=cte*wh/20; float xv=cte*wv/20;
	float yh=cte*hh/20; float yv=cte*hv/20;
	x0=(xx2+xx0)/20;x3=(xx0+xx3)/20;x6=(xx3+xx1)/20;x9=(xx1+xx2)/20;
	y0=(yy2+yy0)/20;y3=(yy0+yy3)/20;y6=(yy3+yy1)/20;y9=(yy1+yy2)/20;
	x1=x0-xv; x11=x0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	y1=y0-yv; y11=y0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	float ym1=(118*Drawing.u-y1);float ym2=(118*Drawing.u-y2);float ym3=(118*Drawing.u-y3);
	float ym4=118*Drawing.u-y4;float ym5=118*Drawing.u-y5;float ym6=118*Drawing.u-y6;
	float ym7=118*Drawing.u-y7;float ym8=118*Drawing.u-y8;float ym9=118*Drawing.u-y9;
	float ym10=118*Drawing.u-y10;float ym11=118*Drawing.u-y11;float ym0=118*Drawing.u-y0;
	double mitet = tet2;if(mitet>2*pi)mitet-=2*pi;
	if(0<=tet1 && tet1<(pi/2)){
	    if(tet21<=(3*pi/2))out.write("("+x6+"u,"+ym6+"u).. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. cycle;\n");
	       else out.write("("+x6+"u,"+ym6+"u).. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. cycle .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u) ;\n");
   }

	if(pi/2<=tet1 && tet1<pi){
	    if(tet21<=(3*pi/2)) out.write("("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. cycle;\n");
	    else out.write("("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. cycle .. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u);\n");
	}
	
	if(pi<=tet1 && tet1<(3*pi/2)){
	    if(tet21<=(3*pi/2))out.write("("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. cycle;\n");
	    else out.write("("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. cycle .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u) ;\n");
	    }

	if((3*pi/2)<=tet1 && tet1<(2*pi)){
	    if(tet21<=(3*pi/2))out.write("("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u) .. cycle;\n");
	    else out.write("("+x9+"u,"+ym9+"u).. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) .. controls ("+x5+"u,"+ym5+"u) and ("+x4+"u,"+ym4+"u)..("+x3+"u,"+ym3+"u).. controls ("+x2+"u,"+ym2+"u) and ("+x1+"u,"+ym1+"u)..("+x0+"u,"+ym0+"u) .. controls ("+x11+"u,"+ym11+"u) and ("+x10+"u,"+ym10+"u)..("+x9+"u,"+ym9+"u) .. cycle .. controls ("+x8+"u,"+ym8+"u) and ("+x7+"u,"+ym7+"u)..("+x6+"u,"+ym6+"u) ;\n");
	}

	out.write("r:=("+xn0+"u,"+yn0+"u)--("+((xn1-xn0)*1.2+xn0)+"u,"+(1.2*(yn1-yn0)*r1+yn0)+"u);\n");
	out.write("s:=("+xn0+"u,"+yn0+"u)--("+xn2+"u,"+((yn2-yn0)*r1+yn0)+"u);\n");

	if(tipo==0){
	    out.write("a:= a cutbefore r cutafter s ;\n");
	    out.write(drw+" a withcolor loc ");
	    if(linea!=0)out.write(tipo_linea);
	    else out.write(";\n");
	    if(refill==1) out.write( "fill a withcolor col;\n" ); 
	    }
	if(tipo==2){
	    out.write("a:= a cutbefore r cutafter s ;\n");
	    out.write("a:= ("+xn0+"u,"+yn0+"u) -- a -- cycle;\n");
	    if(refill==1) out.write("fill a withcolor col;\n"); 
	    out.write(drw+" a withcolor loc ");
	    if(linea!=0)out.write(tipo_linea);
	    else out.write(";\n");
	    }
	    }
	catch (IOException ex) { }            
    }

    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	if((int)(xd[0]-R1)<xmin) xmin = (int)(xd[0]-R1-5);
	if((int)(xd[0]-R2)<xmin) xmin = (int)(xd[0]-R2-5);
	if((int)(yd[0]-R1)<ymin) ymin = (int)(yd[0]-R1-5);
	if((int)(yd[0]-R2)<ymin) ymin = (int)(yd[0]-R2-5);
	if((int)(xd[0]+R1)>xmax) xmax = (int)(xd[0]+R1+5);
	if((int)(xd[0]+R2)>xmax) xmax = (int)(xd[0]+R2+5);
	if((int)(yd[0]+R1)>ymax) ymax = (int)(yd[0]+R1+5);
	if((int)(yd[0]+R2)>ymax) ymax = (int)(yd[0]+R2+5);
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<7;i++)
	    {
		xd[i] += (double)xx;
		yd[i] += (double)yy;
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1 && select<10)
	    {
		xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
	    }
	else if(select==10)dd+=(double)yy/Drawing.u;
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    { 
		if((xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u) ||
		   (i==3 && xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u))
		    {
			select = i+2;
			return(true);
		    }

	    }
	if(xx-(int)xd[0]<5*Drawing.u && xx-(int)xd[0]>-5*Drawing.u && yy-(int)(yd[0]+dd)<5*Drawing.u && yy-(int)(yd[0]+dd*Drawing.u)>-5*Drawing.u){
	    select=10;
	    return(true);
	}
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xd[n] = (double)xx;
	yd[n] = (double)yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
	if(xd[2]!=0)return(true);
	return(false);
    }

    GeneralPath daForma(double px0, double px1, double px2, double px3, double py0, double py1, double py2, double py3)
    {
	float xx0=(float)px0, xx1=(float)px1, xx2=(float)px2, xx3=(float)px3, yy0=(float)py0, yy1=(float)py1, yy2=(float)py2, yy3=(float)py3;
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float xh=cte*wh/2; float xv=cte*wv/2;
	float yh=cte*hh/2; float yv=cte*hv/2;
	xn0=(xx2+xx0)/2;x3=(xx0+xx3)/2;x6=(xx3+xx1)/2;x9=(xx1+xx2)/2;
	yn0=(yy2+yy0)/2;y3=(yy0+yy3)/2;y6=(yy3+yy1)/2;y9=(yy1+yy2)/2;
	xn1=xn0-xv; x11=xn0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	yn1=yn0-yv; y11=yn0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	a= Math.sqrt((xn0-xc)*(xn0-xc)+(yn0-yc)*(yn0-yc));
	b= Math.sqrt((x3-xc)*(x3-xc)+(y3-yc)*(y3-yc));
	if(a>=b)
	{
	    exi=a; emi=b;
	    foc=a-Math.sqrt(a*a-b*b);
	    xf1=xc+((a-foc)/a)*(x6-xc);
	    yf1=yc+((a-foc)/a)*(y6-yc);
	    xf2=xc+((a-foc)/a)*(xn0-xc);
	    yf2=yc+((a-foc)/a)*(yn0-yc);
	}
	else
	{
	    exi=b; emi=a;
	    foc=b-Math.sqrt(b*b-a*a);
	    xf1=xc+((b-foc)/b)*(x9-xc);
	    yf1=yc+((b-foc)/b)*(y9-yc);
	    xf2=xc+((b-foc)/b)*(x3-xc);
	    yf2=yc+((b-foc)/b)*(y3-yc);
	}

	GeneralPath elipse = new GeneralPath();
	elipse.moveTo(xn0,yn0);
	elipse.curveTo(xn1,yn1,x2,y2,x3,y3);
	elipse.curveTo(x4,y4,x5,y5,x6,y6);
	elipse.curveTo(x7,y7,x8,y8,x9,y9);
	elipse.curveTo(x10,y10,x11,y11,xn0,yn0);
	return(elipse);
    }

}
