import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//********************************************************************

class Objetos_group extends Objetos implements Cloneable

//********************************************************************
{
    static final long serialVersionUID = -2495235162678078069L;
    double xxc; 
    double yyc;                     
    Color c;

    Objetos_list glist;

    Objetos_group(Objetos_list p, Objetos_list q)
    {
	super(p);
	glist = new Objetos_list();
	unir=false;
	gru=true;
	Objetos i,ii;
	select = 0;	

	for(i = q.ghead;i!=null;i=ii)
	    {
		ii = i.next;

		if(i.select!=0)
		    {
			i.unlink();
			i.link(glist);
			i.select = 0;
		    }
	    }
	select = 1;
	xmin = ymin = 200000;
	xmax = ymax = -200000;

	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
	    }
	xg[0]=xmin; xg[1]=xmax; yg[0]=ymin; yg[1]=ymax;
       	xd[0]=(double)xmin; xd[1]=(double)xmax; 
	yd[0]=(double)ymin;yd[1]=(double)ymax;
	xc = (double)((xmin+xmax)/2);
	yc = (double)((ymin+ymax)/2);
	zc = 0.;
    }

    public void ungroup()
    {
      Objetos i;
	for(i=glist.ghead;i!=null;i=i.next)
	  {
	    if(this.unir==true) return;
	    i.select = 1;
	  }
	if(parent.ghead==null)
	  parent.ghead = glist.ghead;
	if(parent.gtail!=null)
	  parent.gtail.next = glist.ghead;
	if(glist.ghead!=null)
	  glist.ghead.prev = parent.gtail;
	parent.gtail = glist.gtail;
	
	for(i=parent.ghead;i!=null;i=i.next)
	    i.parent = parent;
	select = 0;
	unlink();
	parent = null;
	next = null;
	prev = null;
    }

    public void setcolor(Color icc)
    {
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.setcolor(icc);
    }

    public void setcolorline(Color icl)
    {
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.setcolorline(icl);
    }

    public void thick()
    {
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.thick();
    }

    public void thin()
    {
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.thin();
    }

    public void setFill(int ifill)
    {
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.setFill(ifill);
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    {
		i.paint(g);
	    }
	if(select!=0)
	    {
		g2.setColor(Color.red);
		g2.drawRect(xmin,ymin,(xmax-xmin),(ymax-ymin));
	    }
	if(select==0)
	{
	    g2.setColor(Color.green);
	    g2.drawRect(xmin,ymin,(xmax-xmin),(ymax-ymin));
	    g2.setColor(cl);
	}
    }
    public void metapost(BufferedWriter out) 
    {     
	for(Objetos i = glist.ghead;i!=null;i=i.next)
	    i.metapost(out);
    }

    public void changeCoor(int change)
    {
	Objetos i;
	xmin = ymin = zmin = 100000;
	xmax = ymax = zmax = -100000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
		if(i.zmin<zmin) zmin = i.zmin;
		if(i.zmax>zmax) zmax = i.zmax;
	    }
	xc = (double)((xmin+xmax)/2);
	yc = (double)((ymin+ymax)/2);
	zc = (double)((zmin+zmax)/2);
	for(i = glist.ghead;i!=null;i=i.next){
	    i.change=change;
	    i.changeCoor(change);}
    }

    public void transform(double xc, double yc, double zc)
    {
	Objetos i;
	ijk=1;
	xmin = ymin = zmin = 100000;
	xmax = ymax = zmax = -100000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
		if(i.zmin<zmin) zmin = i.zmin;
		if(i.zmax>zmax) zmax = i.zmax;
	    }
	for(i = glist.ghead;i!=null;i=i.next){
	    i.value=value;
	    i.setEscal(Objetos.es);
	    i.transform(xc, yc, zc);
	}
    }
    public void moveobj(int x,int y)
    {
	Objetos i;

	for(i = glist.ghead;i!=null;i=i.next)
	    i.moveobj(x,y);
	xmin = ymin = 100000;
	xmax = ymax = -100000;
	for(i = glist.ghead;i!=null;i=i.next)
	    {
		if(i.xmin<xmin) xmin = i.xmin;
		if(i.ymin<ymin) ymin = i.ymin;
		if(i.xmax>xmax) xmax = i.xmax;
		if(i.ymax>ymax) ymax = i.ymax;
	    }

    }

    public boolean selectpoint(int x,int y)
    {
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	x=Drawing.xs;
	y=Drawing.ys;
	if(((Math.abs(x-xmin)<8 || Math.abs(x-xmax)<8 || Math.abs(y-ymin)<8 || Math.abs(y-ymax)<8)) && (x>xmin-5 && x<xmax+5 && y>ymin-5 && y<ymax+5))
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
