import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_line extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 8661534154471892548L;
    Color c;
    Color black = new Color(0,0,0);
    Color white = new Color(255,255,255);
    int x0,y0,x1,y1;
    int esy=1180;
    int n, ikk=0;
    Objetos_line(int xx0,int yy0,Color cc,Objetos_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	n = 2;
	nombre="line";
	select = 3;
    }

    Objetos_line(double xx0,double yy0,double xx1,double yy1,Color cc,Objetos_list p)
    {
	super(p);
	xd[0] = xx0;
	yd[0] = yy0;
	xd[1] = xx1;
	yd[1] = yy1;
	nombre="line";
	select = 0;
	cl=cc;
	ikk=1;
    }

    public void transform(double xc, double yc, double zc)
    {
	ikk=1;
	modi(xc,yc,zc,n);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
	ikk=1;
    }

    public void paint(Graphics g) 
    {
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	if(ikk==0){xd[0]=(double)x0;xd[1]=(double)x1;yd[0]=(double)y0;yd[1]=(double)y1;}
	setminmax();
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	int x = (int)xd[0];
	int y = (int)yd[0];
	if(x>(int)xd[1]) x = (int)xd[1];
	if(y>(int)yd[1]) y = (int)yd[1];
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
	g2.setStroke(stroke);

	if(select!=0)
      	    {
		g.setColor(Color.red);
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
      		g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
		g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    }
	else
	    {
		g.setColor(cl);
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
		if(putarr == true)
		    {
		g.setColor(Color.blue);
			if((numarr/10)%10 == 1 && numarr%10 != 2) g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
			if(numarr%10 == 2) g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
			if((numarr/10)%10 == 2) 
			    {
				g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
				g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
			    }
		    }
		g.setColor(cl);
		x0=(int)xd[0];x1=(int)xd[1];y0=(int)yd[0];y1=(int)yd[1];
	    }
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	g.setColor(cl);
    }

    public void metapost(BufferedWriter out) 
    {
	try 
	    {
	      if(cl==white)cl=black;
		float rc = (float) cl.getRed()/255f;
		float vc = (float) cl.getGreen()/255f;
		float ac = (float) cl.getBlue()/255f;
		float esy0 = 1180f - (float)(yd[0]/uesc);
		float esy1 = 1180f - (float)(yd[1]/uesc);
		if(putarr == true)
		    {
			if(miArrow0 != "")out.write(miArrow0);
			if(miArrow1 != "")out.write(miArrow1);
			if(miArrow2 != "")out.write(miArrow2);
			if(miArrow3 != "")out.write(miArrow3);
		    }
	        out.write("pickup pencircle scaled "+thickness+";\npath a;\n");
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			out.write("a:= ("+(float)(xd[0]/uesc)+"u,"+(float)esy0+"u)--("+(float)(xd[1]/uesc)+"u,"+esy1+"u);\n") ;
			out.write(drw+" a withcolor loc "); 
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
	    }
	catch (IOException ex) { }
    }

    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	for(int i=0;i<2;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
	    }
    }

    public void moveobj(int xx,int yy)
    {
	x0 += xx; xd[0] += (double)xx;
	y0 += yy; yd[0] += (double)yy;
	x1 += xx; xd[1] += (double)xx;
	y1 += yy; yd[1] += (double)yy;
	setminmax();
    }

  public void mueveobjeto(double a, double b, double c, double d)
  {
    xd[0]=a;yd[0]=b;xd[1]=c;yd[1]=d;
  }

    public void movepoint(double x,double y)
    {
	if(select==3){ xd[1] += x; yd[1] += y;}
	if(select==2){ xd[0] += x; yd[0] += y;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	if(xx-(int)xd[0]<3 && xx-(int)xd[0]>-3 && yy-(int)yd[0]<3 && yy-yd[0]>-3)
	    {
		select = 2;
		return(true);
	    }
	if(xx-(int)xd[1]<3 && xx-(int)xd[1]>-3 && yy-(int)yd[1]<3 && yy-yd[1]>-3)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }
   
    public boolean selectobj(int xx,int yy)
    {
	setminmax();
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
    
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	setminmax();
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		setminmax();
		select = 1;
		return(true);
	    }
	return(false);
    }
}
