import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_mpcircle extends Objetos

//***********************************************************************

{
    static final long serialVersionUID = 8165827834765595667L;
    Color c;
    int x0,x1,y0,y1,z0,z1,R,w1,h1;
    double R1, R2; 
    double xdd[]=new double[12]; 
    double ydd[]=new double[12];
    int n,i,stat=5,x0_old,y0_old;
    double r2;
    double dumxd[] = new double[64]; double dumyd[] = new double[64];
    double angulo, escal;
    Objetos_punto mi1;
    Objetos_punto mi2;
    Rectangle mirc;

    Objetos_mpcircle(Objetos_punto p1,Objetos_punto p2,Objetos_list p)
  {
    super(p);
	n = 2;
	nombre = "mpc";
	select = 3;
	mi1 = p1;
	mi2 = p2;
  }

    Objetos_mpcircle(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	xd[0]=x0; xd[1]=x1; yd[0]=y0; yd[1]=y1;
	n = 2;
	nombre = "mpc";
	select = 3;
    }

    public void transform(double xc, double yc, double zc)
    {
	double ij, ji;
	ijk=1;
	n=2;
	if(value==0 || value==1 || value==2 || value==3 || value==5 || value==6 || value==9 || value==11 || value==12 || value==14)
	    {
		aviso.mostrar(true);
	    }
	else if(value!=0 && value!=15) modi(xc,yc,zc,n);
	T =(float)0.0;
    	escal=Math.abs(es/10);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
	z0=(int)zd[0];
	z1=(int)zd[1];
	if(value==7)xscal=(float)(escal/10);
	if(value==8)yscal=(float)(escal/10);
	if(value==10){xscal=(float)(escal/10);yscal=xscal;}
	if(value==4)T=(float)(escal/100);
    }

    public void paint(Graphics g) 
    {
	n=2;int x,y;
	c = cc;
	Graphics2D g2 = (Graphics2D)g ;

	if(mi1!=null)
	  {
	    xd[0] = mi1.xd[0]; yd[0] = mi1.yd[0]; 
	    xd[1] = mi2.xd[0]; yd[1] = mi2.yd[0];
	  }
	xc=xd[0];yc=yd[0];zc=zd[0];
	x0=(int)xd[0]; x1=(int)xd[1];
	y0=(int)yd[0]; y1=(int)yd[1];
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	R1=Math.sqrt((xd[1]-xd[0])*(xd[1]-xd[0])+(yd[1]-yd[0])*(yd[1]-yd[0]));
	R=(int)R1;
	setminmax();
	if(select!=0)
	    {
		g.setColor(Color.red);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		g2.drawLine(x0,y0,x1,y1);
		g.fillRect(x0-1,y0-1,3,3);
		g.fillRect(x1-1,y1-1,3,3);
		g.drawOval((int)(xd[0]-R1),(int)(yd[0]-R1), (int)(2*R1), (int)(2*R1));
		g.setColor(cl);
		setminmax();
	    }
	if(select==0)
	    {
		g.setColor(cl);
		stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);

	    if(refill==0)
		{
		    g.drawOval((int)(xd[0]-R1),(int)(yd[0]-R1),(int)(2*R1), (int)(2*R1));
		}
	    if(refill==1)
		{
		    g.setColor(cc);
		    g.fillOval((x0-R),(y0-R), 2*R, 2*R);
		    g.setColor(cl);
		    g.drawOval((x0-R),(y0-R), 2*R, 2*R);
		}
	    if(espi>1)
		{
		    for(int kk=1;kk<=espi;kk++)
			{
			    int rr=(int)(R1/espi);
			    g.drawOval((int)(xd[0]-(kk*rr)),(int)(yd[0]-(kk*rr)), 2*(kk*rr), 2*(kk*rr));
			}
		}
	    
	    }
	if(select!=2)
	{
       	R2 = (double)cte*R1 ;
	GeneralPath mpcir = new GeneralPath();
	mpcir.moveTo((float)(xd[0]+R1),(float)yd[0]);
	mpcir.curveTo((float)(xd[0]+R1),(float)(yd[0]+R2),(float)(xd[0]+R2),(float)(yd[0]+R1),(float)xd[0],(float)(yd[0]+R1));
	mpcir.curveTo((float)(xd[0]-R2),(float)(yd[0]+R1),(float)(xd[0]-R1),(float)(yd[0]+R2),(float)(xd[0]-R1),(float)yd[0]);
	mpcir.curveTo((float)(xd[0]-R1),(float)(yd[0]-R2),(float)(xd[0]-R2),(float)(yd[0]-R1),(float)xd[0],(float)(yd[0]-R1));
	mpcir.curveTo((float)(xd[0]+R2),(float)(yd[0]-R1),(float)(xd[0]+R1),(float)(yd[0]-R2),(float)(xd[0]+R1),(float)yd[0]);

	forma[12] = (Shape)mpcir;
	mirc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
	if(g2.hit(mirc,forma[12],true)) inters=true;
	else inters=false; 
	}
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	g.setColor(cl);
    }

   public void metapost(BufferedWriter out) 
    {
	c=cc;
	try 
	    {
		float rc = (float) cl.getRed()/255f;
		float vc = (float) cl.getGreen()/255f;
		float ac = (float) cl.getBlue()/255f;
		float ny0 = (float)(118*Drawing.u)-(float)(yd[0]/(10*uesc));
		angulo = Math.atan2((yd[1]-yd[0]),(xd[1]-xd[0])) ;
		out.write("pickup pencircle scaled "+thickness+";\npath a;\n");
		if(espi<2)
		    {
			out.write("a:= fullcircle scaled "+(2*R1/(10*uesc))+"u;\n");
			
			if(refill == 1)
			    {
				float cr = (float) c.getRed()/255f;
				float cv = (float) c.getGreen()/255f;
				float ca = (float) c.getBlue()/255f;
				out.write ("col:=("+cr+","+cv+","+ca+");\n");
				out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			    }
		    }
		float valx=(float)(xd[0]/(10*uesc)),valy=ny0,w=(float)(R1/(40*espi*uesc));
		if(espi>1)
		    {
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			out.write("a:=(0u,0u);\n");
			out.write("for i=1 step 4 until "+(int)(espi*4)+":\n");
			if(sentido==0)out.write("a:=a..(0u,(0-i*"+w+")*u)..((0-(i+1)*"+w+")*u,0u)..(0u,(0+(i+2)*"+w+")*u)..((0+(i+3)*"+w+")*u,0u);\n");
			else out.write("a:=a..(0u,(0-i*"+w+")*u)..((0+(i+1)*"+w+")*u,0u)..(0u,(0+(i+2)*"+w+")*u)..((0-(i+3)*"+w+")*u,0u);\n");
			out.write("endfor;\n");
		    }
		if(text_on_path==false)
		    {
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			if(refill == 1){out.write("filldraw a  shifted("+valx+"u, "+valy+"u) withcolor col;\n");}
			out.write("draw a xscaled "+xscal+" yscaled "+yscal+" slanted "+T+" rotated "+(float)(angulo*(-180)/(float)pi)+" shifted("+valx+"u, "+valy+"u) withcolor loc ");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
    catch (IOException ex) { }
}

    public void moveobj(int x,int y)
    {
	x1 += x; xd[1] += (double)x;
	x0 += x; xd[0] += (double)x;
	y1 += y; yd[1] += (double)y;
	y0 += y; yd[0] += (double)y;

	xmin = (int)(xd[0]-R1) ; xmax = (int)(xd[0]+R1) ; 
	ymin = (int)(yd[0]-R1) ; ymax = (int)(yd[0]+R1) ; 
    }

    public void movepoint(int x,int y)
    {
	if(select==2)
	    {
		x0 += x; xd[0] += (double)x;
		y0 += y; yd[0] += (double)y;
	    }
	if(select==3)
	    {
		x1 += x; xd[1] += (double)x;
		y1 += y; yd[1] += (double)y;
	    }
	if(x0<x1) { xmin = x0 ; xmax = x1 ; }
	else      { xmin = x1 ; xmax = x0 ; }
	if(y0<y1) { ymin = y0 ; ymax = y1 ; }
	else      { ymin = y1 ; ymax = y0 ; }
	setminmax();
    }

    public boolean selectpoint(int x,int y)
    {
	if(x-(int)xd[0]<3*Drawing.u && x-(int)xd[0]>-3*Drawing.u && y-(int)yd[0]<3*Drawing.u && y-(int)yd[0]>-3*Drawing.u)
	    {
		select = 2;
		return(true);
	    }
	else if(x-(int)xd[1]<3*Drawing.u && x-(int)xd[1]>-3*Drawing.u && y-(int)yd[1]<3*Drawing.u && y-(int)yd[1]>-3*Drawing.u)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	setminmax();
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void setminmax()
    {
	R=(int)R1;
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	if((int)(xd[0]-R1)<xmin) xmin = (int)(xd[0]-(R1+2));
	if((int)(yd[0]-R1)<ymin) ymin = (int)(yd[0]-(R1+2));
	if((int)(xd[0]+R1)>xmax) xmax = (int)(xd[0]+(R1+2));
	if((int)(yd[0]+R1)>ymax) ymax = (int)(yd[0]+(R1+2));

    }
}
