import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//**********************************************************************

class Objetos_poly extends Objetos

//**********************************************************************

{
    static final long serialVersionUID = -2414019613661075669L;
    Color c, lblue=new Color(80,80,255);
    double alfa, alfa_old, xxc, yyc, longit=1, longit_old=1;
    int n;
    int junta=Drawing.join;
    int junta_old=Drawing.join_last;

    Objetos_poly(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    Objetos_poly(int xxg[],int yyg[],int np,Objetos_list p)
    {
	super(p);
	int i ;
        for (i=0;i<np;i++) {
	     xg[i] = xxg[i] ;
	     yg[i] = yyg[i] ;
	     if (xmin > xg[i]) xmin  = xg[i]-5 ;
	     if (xmax < xg[i]) xmax  = xg[i]+5 ;
	     if (ymin > yg[i]) ymin  = yg[i]-5 ;
	     if (ymax < yg[i]) ymax  = yg[i]+5 ;
	     }
	n = np;
	select = 0;
    }

    Objetos_poly(double xxg[],double yyg[],int np,Objetos_list p)
    {
	super(p);
	int i ;
	xmax=-100000;ymax=-100000;xmin=100000;ymin=100000;
        for (i=0;i<np;i++) {
	     xd[i] = xxg[i] ;
	     yd[i] = yyg[i] ;
	     xg[i] = (int)xxg[i] ;
	     yg[i] = (int)yyg[i] ;
	     if (xmin > xg[i]) xmin  = xg[i]-5 ;
	     if (xmax < xg[i]) xmax  = xg[i]+5 ;
	     if (ymin > yg[i]) ymin  = yg[i]-5 ;
	     if (ymax < yg[i]) ymax  = yg[i]+5 ;
	     }
	n = np;
	for(int ii=0; ii<n; ii++){xxc+=xd[ii];yyc+=yd[ii];}
	xc=xxc/n; yc=yyc/n;
	xd[n]=xc+40;yd[n]=yc;
	xd[n+1]=xc;yd[n+1]=yc-40;
	ijk=1;
	select = 0;
    }

    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0,i;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	Polygon p = new Polygon();
	for(i=0;i<n;i++) p.addPoint(xg[i],yg[i]);
	if(ijk==0)for(i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	else for(i=0;i<n;i++){xg[i]=(int)xd[i];yg[i]=(int)yd[i]; }
	setminmax();
	xxc=0;yyc=0;
	for(int ii=0; ii<n; ii++){xxc+=xd[ii];yyc+=yd[ii];}
	xc=xxc/n; yc=yyc/n;
	if(ijk==0){xd[n]=xc+40;yd[n]=yc;xd[n+1]=xc ;yd[n+1]=yc-40  ;}
	Shape Pol = (Shape)(p);
	GeneralPath lin = new GeneralPath();
	lin.moveTo((float)xc,(float)yc);
	lin.lineTo((float)xd[n],(float)yd[n]);
	GeneralPath lin2 = new GeneralPath();
	lin2.moveTo((float)xc,(float)yc);
	lin2.lineTo((float)xd[n+1],(float)yd[n+1]);
	Shape cont = (Shape)lin;
	Shape cont2 = (Shape)lin2;
	
	if(select!=0)
	    {
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		g2.setColor(Color.red) ;
		g2.draw(Pol);
		for(i = 0;i<n;i++) g2.fillRect((int)xd[i]-1,(int)yd[i]-1,3,3);
		if(n>2 && Drawing.ggll==1){
		g2.setColor(Color.blue);
		g2.draw(cont);
		g2.draw(cont2);
		g2.fillRect((int)xd[n]-1,(int)yd[n]-1,3,3);
		g2.fillRect((int)xd[n+1]-1,(int)yd[n+1]-1,3,3);
		g2.drawOval((int)xd[n]-3,(int)yd[n]-3,7,7);
		g2.drawLine((int)xd[n+1]-4,(int)yd[n+1],(int)xd[n+1]+4,(int)yd[n+1]);
		g2.drawLine((int)xd[n+1],(int)yd[n+1]-4,(int)xd[n+1],(int)yd[n+1]+4);
		g2.fillRect((int)xc-1,(int)yc-1,3,3);
		if(Math.abs(alfa) > 0.0001)Drawing.src32.setText("a1="+(float)((int)(alfa*1800/pi))/10);
		if(Math.abs(longit) > 0.0001)Drawing.src33.setText("es="+(float)((int)(longit*100))/100);

		}
	    }
	if(select==0 && refill==1)
	    { 
		g2.setColor(cc); 
		g2.fill(Pol);
	    }
	if(select==0)
	    {
		stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		g2.setColor(cl) ;
		g2.draw(Pol);
	    }

	rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
        if(g2.hit(rc,Pol,true)) inters=true;
	else inters=false;

	if(junta!=junta_old)Drawing.join_last=junta;
	g2.setColor(cl);
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
    }

    public void metapost(BufferedWriter out) 
    {
	c=cc;
	float ny0 = (float)(118*Drawing.u-yd[0]/(10*uesc)); 
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
   	try 
	    {
		int sy0=118*Drawing.u-(int)(yd[0]/(10*uesc));
		int sy1=118*Drawing.u-(int)(yd[1]/(10*uesc));
		out.write ("pickup pencircle scaled "+thickness+";\n");
		if(junta != junta_old){
		    if(junta%3==1 && junta!=1)out.write("linejoin:=rounded;\n");
		    if(junta%3==2)out.write("linejoin:=mitered;\n");
		    if(junta%3==0)out.write("linejoin:=beveled;\n");
		}

		if(refill==1)
		    {
			float cr = (float) c.getRed()/255f;
			float cv = (float) c.getGreen()/255f;
			float ca = (float) c.getBlue()/255f;
			out.write ("col:=("+cr+","+cv+","+ca+");\n"); 

			out.write("filldraw ("+(float)(xd[0]/(10*uesc))+"u,"+ny0+"u)--(");
			for(int i=1;i<n;i++)
			    out.write((float)(xd[i]/(10*uesc))+"u,"+(float)(118*Drawing.u-yd[i]/(10*uesc))+"u)--("); 
			out.write((float)(xd[0]/(10*uesc))+"u,"+ny0+"u)--cycle withcolor col;\n");
		    }
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n"); 
		out.write("draw ("+(float)(xd[0]/(10*uesc))+"u,"+ny0+"u)--(");
		for(int i=1;i<n;i++)
		    out.write((float)(xd[i]/(10*uesc))+"u,"+(float)(118*Drawing.u-yd[i]/(10*uesc))+"u)--(");
		out.write((float)(xd[0]/(10*uesc))+"u,"+ny0+"u)--cycle");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		    {
			out.write(" withcolor loc");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }
		else 		
		    {
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }	
	    }
	catch (IOException ex) { } 
	} 

    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	zmax = -100000;
	zmin = 100000;
	
	if(ijk==1)
	    for(int i=0;i<n+2;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)xd[i]-5  ;
		    if(yd[i]<(double)ymin) ymin = (int)yd[i]-5  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+5)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+5)  ;
		    if(zd[i]<(double)zmin) zmin = (int)zd[i]-5  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+5)  ;
		}
	
	if(ijk==0)
	    for(int i=0;i<n;i++)
		{
		    if(xg[i]<xmin) xmin = xg[i]-5;
		    if(yg[i]<ymin) ymin = yg[i]-5;
		    if(xg[i]>xmax) xmax = xg[i]+5;
		    if(yg[i]>ymax) ymax = yg[i]+5;
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(ijk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ijk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ijk==0)
		    {
		xg[select-2] += xx;
		yg[select-2] += yy;
		if(select==n+2 || select==n+3)ijk=1;
		    }
		if(ijk==1)
		    {
		if(select!=n+3)xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
		if(select==n+2){girar();setminmax();}
		if(select==n+3){ampliar();setminmax();}
		    }
	    }
	if(select==1 && ijk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ijk==1)
	    for(int i=0;i<n;i++) {xd[i]+=(double)xx; yd[i]+=(double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }
 
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
	if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	    {
		n--;
		return(true);
	    }
	return(false);
    }

    public void girar() 
    {
	double xp, yp, s, c;
	alfa_old=alfa;
	xc=xxc/n;
	yc=yyc/n;;
	alfa=Math.atan2((yd[n]-yc),(xd[n]-xc));
	s=Math.sin(alfa-alfa_old); c=Math.cos(alfa-alfa_old);
	for(int i=0; i<n; i++){
	xp=(xd[i]-xc)*c-(yd[i]-yc)*s+xc;
	yp=(xd[i]-xc)*s+(yd[i]-yc)*c+yc;
	xd[i]=xp;yd[i]=yp;
	}
    }

    public void ampliar() 
    {
	double xp, yp;
	longit_old=longit;
	xc=xxc/n;
	yc=yyc/n;
	if(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc))<5)return;
	longit=(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc)))/(40*Drawing.u);
	for(int i=0; i<n; i++){
	xd[i]=(xd[i]-xc)*(longit/longit_old)+xc;
	yd[i]=(yd[i]-yc)*(longit/longit_old)+yc;
	}
    }






}
