import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//**************************************************************************

class Objetos_rect extends Objetos

//**************************************************************************
{
    static final long serialVersionUID = 326143662792263705L;
    Color c;
    int x0,y0,x1,y1,w,h;
    int miEs = Drawing.u;

    Objetos_rect(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	nombre="rec";
	select = 5;
    }

    Objetos_rect(int xx0,int yy0,int xx1,int yy1,Objetos_list p)
    {
	super(p);
	x0 =  xmin = xx0;
	y0 = ymin = yy0;
	x1 =  xmax = xx1;
	y1 =  ymax = yy1;
	nombre="rec";
	select = 5;
    }

    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,4);
      	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	int x = x0;
	int y = y0;
	w = x1-x0;
	h = y1-y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;
	if(w<0) w = -w;
	if(h<0) h = -h;
	if(ijk==0){
	xd[0]=(double)x0;yd[0]=(double)y0;xd[1]=(double)x1;yd[1]=(double)y1;
	xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];xd[4]=(xd[0]+xd[1])/2+60;yd[4]=(yd[0]+yd[1])/2;
	}
	x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	xc = (xd[0]+xd[1]+xd[2]+xd[3])/4.;
	yc = (yd[0]+yd[1]+yd[2]+yd[3])/4.;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	GeneralPath rectan = new GeneralPath();
      	rectan.moveTo((float)xd[0],(float)yd[0]);
	rectan.lineTo((float)xd[3],(float)yd[3]);	
	rectan.lineTo((float)xd[1],(float)yd[1]);	
	rectan.lineTo((float)xd[2],(float)yd[2]);
	rectan.closePath();
	forma[2] = (Shape) rectan; 

	if (select != 0)
	{
	    g2.setColor(Color.red);
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    g2.draw(forma[2]);
	    g2.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
	    g2.fillRect((int)xd[2]-1,(int)yd[2]-1,3,3);
	    g2.fillRect((int)xd[3]-1,(int)yd[3]-1,3,3);
	    g2.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    g2.setColor(Color.blue);
	    g2.drawLine((int)xc,(int)yc,(int)xd[4],(int)yd[4]);
	    g2.fillRect((int)xd[4]-1,(int)yd[4]-1,3,3);
	    g2.fillRect((int)xc-1,(int)yc-1,3,3);
	}

	if (select == 0 )
	    {
		stroke = new BasicStroke(thickness);
		if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		if(refill==1)
		    {
			g2.setColor(cc); 
			g2.fill(forma[2]);
		    }
		g2.setColor(cl);
		g2.draw(forma[2]);
	    }
	
	rc=new Rectangle(xsel-5,ysel-5,11,11);
        if(g2.hit(rc,forma[2],true)) inters=true;
	else inters=false;
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	g2.setColor(cl);
    }
    
    public void metapost(BufferedWriter out) 
    {
	c=cc;
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;

   	try {
	    float sy0 = (float)(118*Drawing.u)-(float)(yd[0]/(10*uesc));float sy2 = (float)(118*Drawing.u) - (float)(yd[2]/(10*uesc));
	    float sy1 = (float)(118*Drawing.u) - (float)(yd[1]/(10*uesc));float sy3 = (float)(118*Drawing.u) - (float)(yd[3]/(10*uesc));
	    float xm0 = (float)(xd[0]/(10*uesc));float xm1 = (float)(xd[1]/(10*uesc));
	    float xm2 = (float)(xd[2]/(10*uesc));float xm3 = (float)(xd[3]/(10*uesc));
	    out.write ("pickup pencircle scaled "+thickness+";\n");
	    if(refill==1)
		{
		    float cr = (float) c.getRed()/255f;
		    float cv = (float) c.getGreen()/255f;
		    float ca = (float) c.getBlue()/255f;
		    out.write ("col:=("+cr+","+cv+","+ca+");\n"); 
		    out.write ("filldraw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--cycle withcolor col;\n");
		}
	    if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		{ 
		    out.write ("loc:=("+rc+","+vc+","+ac+");\n");  
		    out.write ("draw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--("+xm0+"u,"+sy0+"u)--cycle withcolor loc ");
		}
	    else out.write ("draw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--("+xm0+"u,"+sy0+"u)--cycle ");
	    {
		if(linea!=0)out.write(tipo_linea);
		else out.write(";\n");
	    }
	}
	catch (IOException ex) { }
    }
    
    public void moveobj(int x,int y)
    {
	if(ijk==0)
	    {
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y; }
		x1 += x;
		x0 += x;
		y1 += y;
		y0 += y;
		if(x0<x1) { xmin = x0-2 ; xmax = x1+2 ; }
		else      { xmin = x1-2 ; xmax = x0+2 ; }
		if(y0<y1) { ymin = y0-2 ; ymax = y1+2 ; }
		else      { ymin = y1-2 ; ymax = y0+2 ; }
	    }
	if(ijk!=0)
	    {
		xmin=100000;xmax=-100000;ymin=100000;ymax=-100000;
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y;                       
			if(xmin>(int)xd[i]-2) xmin=(int)xd[i]-2;
			if(xmax<(int)xd[i]+2) xmax=(int)xd[i]+2;
			if(ymin>(int)yd[i]-2) ymin=(int)yd[i]-2;
			if(ymax<(int)yd[i]+2) ymax=(int)yd[i]+2;
		    }
	    }
    }

    public void movepoint(int x,int y)
    {
	if(ijk==0)
	    {
		if(select==6){xd[4]+=(double)x;yd[4]+=(double)y; girar();}
		if(select==5 || select==3)x1 += x; 
		if(select==4 || select==2)x0 += x;
		if(select==5 || select==4)y1 += y;
		if(select==3 || select==2)y0 += y;
		if(x0<x1) { xmin = x0-1 ; xmax = x1+1 ; }
		else      { xmin = x1-1 ; xmax = x0+1 ; }
		if(y0<y1) { ymin = y0-1 ; ymax = y1+1 ; }
		else      { ymin = y1-1 ; ymax = y0+1 ; }
	    }
	else
	    {
		double xx, yy;
		xx=(double)x; yy=(double)y;
		if(select==6){xd[4]+=(double)x;yd[4]+=(double)y; girar();}
		if(select==5)reescal(xx,yy,1);
		if(select==4)reescal(xx,yy,2);
		if(select==3)reescal(xx,yy,3);
		if(select==2)reescal(xx,yy,0);
		xmin=100000;xmax=-100000;ymin=100000;ymax=-100000;
		for(int k=0; k<4; k++) {
		if(xmin>(int)xd[k])xmin=(int)xd[k]-2;
		if(ymin>(int)yd[k])ymin=(int)yd[k]-2;
		if(xmax<(int)xd[k])xmax=(int)xd[k]+2;
		if(ymax<(int)yd[k])ymax=(int)yd[k]+2;
		}
	    }
    }

    public boolean selectpoint(int x,int y)
    {
	double xx, yy;
	xx=(double)x; yy=(double)y;

	if((x-x0<5 && x-x0>-5 && y-y0<5 && y-y0>-5) || (xx-xd[0]<5. && xx-xd[0]>-5. && yy-yd[0]<5. && yy-yd[0]>-5.))
	    {
		select = 2;
		return(true);
	    }
	if((x-x1<5 && x-x1>-5 && y-y0<5 && y-y0>-5) || (xx-xd[3]<5. && xx-xd[3]>-5. && yy-yd[3]<5. && yy-yd[3]>-5.))
	    {
		select = 3;
		return(true);
	    }
	if((x-x0<5 && x-x0>-5 && y-y1<5 && y-y1>-5) || (xx-xd[2]<5. && xx-xd[2]>-5. && yy-yd[2]<5. && yy-yd[2]>-5.))
	    {
		select = 4;
		return(true);
	    }
	if((x-x1<5 && x-x1>-5 && y-y1<5 && y-y1>-5) || (xx-xd[1]<5. && xx-xd[1]>-5. && yy-yd[1]<5. && yy-yd[1]>-5.))
	    {
		select = 5;
		return(true);
	    }
	return(false);
	if((xx-xd[4]<5. && xx-xd[4]>-5. && yy-yd[4]<5. && yy-yd[4]>-5.))
	    {
		select = 6;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void reescal(double x, double y, int nodo)
    {
	double xp, yp, alfa, s, c;
	alfa=Math.atan((yd[3]-yd[0])/(xd[3]-xd[0]));
	s=Math.sin(alfa); c=Math.cos(alfa);
	xp=x*c+y*s;
	yp=-x*s+y*c;
	xd[nodo]+=x;yd[nodo]+=y;
	if(nodo==0){
	xd[3]-=yp*s;
	yd[3]+=yp*c;
	xd[2]+=xp*c;
	yd[2]+=xp*s;
	}
	if(nodo==1){
	xd[2]-=yp*s;
	yd[2]+=yp*c;
	xd[3]+=xp*c;
	yd[3]+=xp*s;
	}
	if(nodo==2){
	xd[1]-=yp*s;
	yd[1]+=yp*c;
	xd[0]+=xp*c;
	yd[0]+=xp*s;
	}
	if(nodo==3){
	xd[0]-=yp*s;
	yd[0]+=yp*c;
	xd[1]+=xp*c;
	yd[1]+=xp*s;
	}
	return;
    }

    public void girar() 
    {
	double xp, yp, alfa, s, c;
	alfa=Math.atan((yd[4]-yc)/(xd[4]-xc));
	s=Math.sin(alfa); c=Math.cos(alfa);
	for(int i=0; i<4; i++){
	xp=xd[i]*c+yd[i]*s;
	yp=-xd[i]*s+yd[i]*c;
	xd[i]=xp;yd[i]=yp;
	}
    }
}
