import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_texto extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 2869328701435804250L;
    double angulo=0, texscal=1 , scal_old=1;
    int colocatext = Drawing.placetext;
    Color c;
    int x0,y0,x1,y1,z0,z1;
    int esy=1180;
    int n;
    String letra = null;
    Objetos_texto(int xx0,int yy0,Color cc,Objetos_list p,String itexto)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	n = 2;
	texto=itexto;
	select = 3;
    }

    Objetos_texto(int xx0,int yy0,int xx1,int yy1,Color cc,Objetos_list p,String itexto)
    {
	super(p);
	x0 =  xmin = xx0;
	y0 = ymin = yy0;
	x1 =  xmax = xx1;
	y1 =  ymax = yy1;
	n = 2;
	texto=itexto;
	select = 3;
    }

    public void newfont(String ifont)
    {
	letra = ifont;
    }

    public void transform(double xc, double yc, double zc)
    {
       	if(value==0 || value==1 || value==2 || value==3 || value==5 || value==6 || value==9 || value==11 || value==12 || value==13 || value==14)
	    {
		aviso2.mostrar(true);
	    }
	else  modi(xc,yc,zc,2);
	T =(float)0.0;
    	texscal=es;//*scal_old;
	if(value==7)xscal=(float)(texscal/100);
	if(value==8)yscal=(float)(texscal/100);
	if(value==10){xscal=(float)(texscal/100);yscal=xscal;}
	if(value==4)T=(float)(texscal/100);
	scal_old=es/100;
    }

    public void paint(Graphics g) 
    {
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	int x = x0;
	int y = y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;

	if(ijk==0){xd[0]=(double)x0;xd[1]=(double)x1;yd[0]=(double)y0;yd[1]=(double)y1;}
	x0=(int)xd[0]; y0=(int)yd[0]; x1=(int)xd[1]; y1=(int)yd[1];
	setminmax();
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;

	float strokeThickness = 1.0f*thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);

	if(select!=0)
      	    {
		g.setColor(Color.red);
		g.drawLine((int)xd[0],(int)yd[0],(int)xd[1],(int)yd[1]);
		g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
		g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    }
	else
	    {
		g.setColor(cl);
		g.drawLine((int)xd[0],(int)yd[0],(int)xd[1],(int)yd[1]);
		angulo = Math.atan2((yd[1]-yd[0]),(xd[1]-xd[0])) ;
		g2.rotate(angulo,(int)xd[0],(int)yd[0]);
		g2.drawString(texto,(int)xd[0],(int)yd[0]);
		g2.rotate(-angulo,(int)xd[0],(int)yd[0]);
	    }

	GeneralPath lline = new GeneralPath();
	lline.moveTo((float)xd[0],(float)yd[0]);
	lline.lineTo((float)xd[1],(float)yd[1]);
	Shape miLINEA = (Shape)lline;

	rc=new Rectangle(xsel-5,ysel-5,11,11);
	if(g2.hit(rc,miLINEA,true))inters=true;
	else inters=false;
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	g2.setColor(cl);
    }

    public void metapost(BufferedWriter out) 
    { 
	float xscal1=1, yscal1=1;
	if(ikk==1){xscal1=xscal*Drawing.u; yscal1=yscal*Drawing.u;}
	else if(ikk==0){xscal1=xscal; yscal1=yscal;}
      	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	try {
	    float ny0 = (float)(118*Drawing.u-yd[0]/(10*uesc));
	    if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("col:=("+rc+","+vc+","+ac+");\n");
	    else out.write("col:=(0,0,0);\n");

	    if(!text_on_path )
		{

		    if(letra==null){
			out.write("picture p;\np:=thelabel(btex "+texto+" etex , (0,0));\n");
	       if(colocatext==1)out.write("draw p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" shifted (("+(float)(xd[0]/(10*uesc))+"u,"+ny0+"u) +(ulcorner p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" -llcorner p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+")/2) withcolor col;\n");
	       else if(colocatext==2)out.write("draw p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" shifted (("+(float)(xd[0]/(10*uesc))+"u,"+ny0+"u) +ulcorner p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" -center p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+") withcolor col;\n");
	       else if(colocatext==0)out.write("draw p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" shifted (("+(float)(xd[0]/(10*uesc))+"u,"+ny0+"u) +center p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+" -llcorner p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/pi)+") withcolor col;\n");
		    }
		    else   out.write("\nprologues:=2;\npicture p;\ndefaultfont:=\""+letra+"\";\np:=thelabel(\""+texto+"\" , (0,0));\ndraw p xscaled "+xscal1+" yscaled "+yscal1+" slanted "+T+" rotated "+(float)(angulo*(-180)/(float)pi)+" shifted ("+(xd[0]/(10*uesc))+"u,"+ny0+"u) withcolor col;\nprologues:=0;\n");
		}

	    if(text_on_path)
		{
		    out.write("color llc;\ninput fonts/txp;\nxscal1:=1; yscal1:=1; slan:=0; scafig:=1; hy:=-3.0; tt:=0.0; sep:=0.0; lin:=0.0;\nstring ss;\n");
    		    if(letra!="")out.write("input fonts/f"+letra+";\ndefaultfont:=\""+letra+"\";\n");
		    out.write("ss:=\""+texto+"\";\n");
		}
	}
	catch (IOException ex) { }
    }

    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	zmax = -100000;
	zmin = 100000;
	for(int i=0;i<2;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]-2  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]-2  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+2)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+2)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]-2  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+2)  ;
	    }
    }
    public void moveobj(int xx,int yy)
{
    x0 += xx; xd[0] += (double)xx;
    y0 += yy; yd[0] += (double)yy;
    x1 += xx; xd[1] += (double)xx;
    y1 += yy; yd[1] += (double)yy;
    setminmax();
}
public void movepoint(int x,int y)
{
    if(select==3){ x1 += x;y1 += y; xd[1] += (double)x; yd[1] += (double)y;}
    if(select==2){ x0 += x;y0 += y; xd[0] += (double)x; yd[0] += (double)y;}
    setminmax();
}

public boolean selectpoint(int xx,int yy)
{
    if(xx-(int)xd[0]<3 && xx-(int)xd[0]>-3 && yy-(int)yd[0]<3 && yy-yd[0]>-3)
    {
	select = 2;
	return(true);
    }
    if(xx-(int)xd[1]<3 && xx-(int)xd[1]>-3 && yy-(int)yd[1]<3 && yy-yd[1]>-3)
    {
	select = 3;
	return(true);
    }
    return(false);
}

public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
{
    setminmax();
    if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
    {
	setminmax();
	select = 1;
	return(true);
    }
    return(false);
}

   public void modi(double xc, double yc, double zc, int nn)
    {
	double x, y, z;
	int n = nn;
	if(value==14){ xc=XX0; yc=YY0; zc=ZZ0; }
	}
}

