import java.awt.*;
import java.awt.event.*;
import javax.swing.* ;
import javax.swing.border.*;

public class Conexiona extends JFrame
{
static final long serialVersionUID = 1105021071263407275L;
    Color back  = new Color(210,210,210);
    Color dgray = new Color(60,60,60);
    Color black = new Color(0,0,0);
    Color white = new Color(255,255,255);
    Color col = new Color(255,0,220);
    Objetos_linea l1,l2,l3,l4;
    Objetos_bezicirc b1, b2;
    Objetos_oval ova1;
    Objetos_punto p1, p2, p3, p4,p5,p6;
    Objetos_arcos ar1, ar2;
    Drawing parent;
    JPanel newtool;
    double cen;
    int mii;

    Conexiona()
{
    newtool = new JPanel();
    newtool.setLayout(new GridLayout(19,2));
    newtool.setSize(40,460);

    setBackground(black);

    Icon twopoint = new ImageIcon("images/twopoint.png");
    Icon atriz = new ImageIcon("images/atriz.png");
    Icon center = new ImageIcon("images/centro.png");
    Icon middpoint = new ImageIcon("images/middpoint.png");
    Icon onelinint = new ImageIcon("images/onelinint.png");
    Icon twocir = new ImageIcon("images/twocir.png");
    Icon perpen = new ImageIcon("images/perpen.png");
    Icon paralela = new ImageIcon("images/paralela.png");
    Icon cort1 = new ImageIcon("images/cort1.png");
    Icon cort2 = new ImageIcon("images/cort2.png");
    Icon tgright = new ImageIcon("images/tgright.png");
    Icon tgleft = new ImageIcon("images/tgleft.png");
    Icon tgs = new ImageIcon("images/tgs.png");
    Icon medi = new ImageIcon("images/medi.png");
    Icon inter = new ImageIcon("images/inter.png");
    Icon intel = new ImageIcon("images/intel.png");
    Icon intel2 = new ImageIcon("images/intel2.png");
    Icon bis = new ImageIcon("images/bis.png");
    Icon tgoval1 = new ImageIcon("images/tgoval1.png");
    Icon tgoval2 = new ImageIcon("images/tgoval2.png");
    Icon inlin = new ImageIcon("images/inlin.png");
    Icon focos = new ImageIcon("images/focos.png");
    Icon ejes = new ImageIcon("images/ejes1.png");
    Icon control = new ImageIcon("images/control1.png");
    Icon circul = new ImageIcon("images/circul.png");
    Icon hexagon = new ImageIcon("images/hexagon.png");
    Icon triangle = new ImageIcon("images/triangle.png");
    Icon pentagon = new ImageIcon("images/pentagon.png");
    Icon arco = new ImageIcon("images/nuarco.png");
    Icon misector = new ImageIcon("images/sector.png");
    Icon trazos = new ImageIcon("images/felipe1.png");
    Icon traz = new ImageIcon("images/felipe2.png");
    Icon mi4point = new ImageIcon("images/puntosrect1.png");
    Icon mi4midd = new ImageIcon("images/puntosrect2.png");
    Icon pint = new ImageIcon("images/puntopinta.png");
    Icon midis1 = new ImageIcon("images/distancia.png");
    Icon dispto1 = new ImageIcon("images/dispuntos.png");
    Icon centroval1 = new ImageIcon("images/centroval.png");
    Icon miscoor1 = new ImageIcon("images/coor.png");
    Icon cte1 = new ImageIcon("images/constante.png");


    JButton pintar = new JButton() ;
    pintar = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    pintar.setIcon(pint);
    pintar.setSize(40,20);
    pintar.setToolTipText("Dibuja la traza de un punto");
    pintar.setBackground(back);
    pintar.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i;
		Objetos_qbrd pin=null;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1 && i.nombre=="pu")
		       pin=new Objetos_qbrd((Objetos_punto)i,black,Drawing.glist);
		    repaint();
		}
	    }
	});

    JButton midis = new JButton() ;
    midis = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    midis.setIcon(midis1);
    midis.setSize(40,20);
    midis.setToolTipText(" ");
    midis.setBackground(back);

    JButton dispto = new JButton() ;
    dispto = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    dispto.setIcon(dispto1);
    dispto.setSize(40,20);
    dispto.setToolTipText(" ");
    dispto.setBackground(back);

    JButton centroval = new JButton() ;
    centroval = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    centroval.setIcon(centroval1);
    centroval.setSize(40,20);
    centroval.setToolTipText(" ");
    centroval.setBackground(back);
    centroval.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			   g= new Objetos_punto((Objetos_oval)i,Drawing.glist);
			}
		    }     
		}
	    }
	});



    JButton miscoor = new JButton() ;
    miscoor = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    miscoor.setIcon(miscoor1);
    miscoor.setSize(40,20);
    miscoor.setToolTipText(" ");
    miscoor.setBackground(back);

    JButton cte = new JButton() ;
    cte = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    cte.setIcon(cte1);
    cte.setSize(40,20);
    cte.setToolTipText(" ");
    cte.setBackground(back);



    JButton mi4med = new JButton() ;
    mi4med = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mi4med.setIcon(mi4midd);
    mi4med.setSize(40,20);
    mi4med.setToolTipText(" ");
    mi4med.setBackground(back);
    mi4med.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,e,f,g,h;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="rec")
			{
			    e= new Objetos_punto((Objetos_rect)i,5,Drawing.glist);
			    f= new Objetos_punto((Objetos_rect)i,6,Drawing.glist);
			    g= new Objetos_punto((Objetos_rect)i,7,Drawing.glist);
			    h= new Objetos_punto((Objetos_rect)i,8,Drawing.glist);
			    repaint();
			}
		    }     
		}
	    }
	});


    JButton mi4pun = new JButton() ;
    mi4pun = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mi4pun.setIcon(mi4point);
    mi4pun.setSize(40,20);
    mi4pun.setToolTipText(" ");
    mi4pun.setBackground(back);
    mi4pun.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,e,f,g,h;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="rr")
			{
			    e= new Objetos_punto((Objetos_round)i,5,Drawing.glist);
			    f= new Objetos_punto((Objetos_round)i,6,Drawing.glist);
			    g= new Objetos_punto((Objetos_round)i,7,Drawing.glist);
			    h= new Objetos_punto((Objetos_round)i,8,Drawing.glist);
			    repaint();
			}
		    }     
		}
	    }
	});


    JButton mitrazo = new JButton() ;
    mitrazo = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mitrazo.setIcon(trazos);
    mitrazo.setSize(40,20);
    mitrazo.setToolTipText(" ");
    mitrazo.setBackground(back);
    mitrazo.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="bzci"){
      p1=new Objetos_punto((Objetos_bezicirc)j,(Objetos_linea)i,9,1,Drawing.glist);
      p2=new Objetos_punto((Objetos_bezicirc)j,(Objetos_linea)i,9,2,Drawing.glist);
      repaint();
      ang_rec((Objetos_bezicirc)j,p1,p2);
      repaint();
      j.delete();
      i.delete();
      p1.delete();
      p2.delete();
				}
			}
			else if(i.nombre=="bzci")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
      p1=new Objetos_punto((Objetos_bezicirc)i,(Objetos_linea)j,9,1,Drawing.glist);
      p2=new Objetos_punto((Objetos_bezicirc)i,(Objetos_linea)j,9,2,Drawing.glist);
      repaint();
      ang_rec((Objetos_bezicirc)i,p1,p2);
      repaint();
      j.delete();
      i.delete();
      p1.delete();
      p2.delete();
				}
			}
		    }     
		}
	    }
	});

    

    JButton mitr = new JButton() ;
    mitr = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mitr.setIcon(traz);
    mitr.setSize(40,20);
    mitr.setToolTipText(" ");
    mitr.setBackground(back);
    mitr.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    p3=new Objetos_punto((Objetos_oval)i,(Objetos_linea)j,6,1,Drawing.glist);
				    p4=new Objetos_punto((Objetos_oval)i,(Objetos_linea)j,6,2,Drawing.glist);
				    p5=new Objetos_punto(p3.xd[0],p3.yd[0]+100.,Drawing.glist);
				    p6=new Objetos_punto(p4.xd[0],p4.yd[0]+100.,Drawing.glist);
				    l2= new Objetos_linea(p3,p5,1,Drawing.glist);
				    b1=new Objetos_bezicirc((Objetos_oval)i, Drawing.glist);
				    repaint();
				    mii=1;cen=b1.yc;
				    if(p3.yd[0]<cen)mii=2;
				    p1=new Objetos_punto(b1,l2,9,mii,Drawing.glist);
				    l3= new Objetos_linea(p4,p6,1,Drawing.glist);
				    mii=1;if(p4.yd[0]<cen)mii=2;
				    p2=new Objetos_punto(b1,l3,9,mii,Drawing.glist);
				    ang_ova((Objetos_oval)i, p1, p2);
				    p3.delete();
				    p4.delete();
				    p5.delete();
				    p6.delete();
				    l2.delete();
				    l3.delete();
				    p1.delete();
				    p2.delete();
				    b1.delete();
				    i.delete();
				    j.delete();
				}
			}

			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){

				    p3=new Objetos_punto((Objetos_oval)j,(Objetos_linea)i,6,1,Drawing.glist);
				    p4=new Objetos_punto((Objetos_oval)j,(Objetos_linea)i,6,2,Drawing.glist);
				    p5=new Objetos_punto(p3.xd[0],p3.yd[0]+100.,Drawing.glist);
				    p6=new Objetos_punto(p4.xd[0],p4.yd[0]+100.,Drawing.glist);
				    l2= new Objetos_linea(p3,p5,1,Drawing.glist);
				    b1=new Objetos_bezicirc((Objetos_oval)j, Drawing.glist);
				    repaint();
				    p1=new Objetos_punto(b1,l2,9,1,Drawing.glist);
				    l3= new Objetos_linea(p4,p6,1,Drawing.glist);
				    p2=new Objetos_punto(b1,l3,9,2,Drawing.glist);
				    ang_ova((Objetos_oval)j, p1, p2);
				    p3.delete();
				    p4.delete();
				    p5.delete();
				    p6.delete();
				    l2.delete();
				    l3.delete();
				    p1.delete();
				    p2.delete();
				    b1.delete();
				    i.delete();
				    j.delete();

				}
			}
		    }     
		}
	    }
	});


    JButton perp = new JButton() ;
    perp = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    perp.setIcon(perpen);
    perp.setSize(40,20);
    perp.setToolTipText("Draws the perpendicular from selected point to selected line");
    perp.setBackground(back);
    perp.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_linea)i,2,Drawing.glist);
				    repaint();
				}
			}

			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_linea)j,2,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton medio = new JButton() ;
    medio = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    medio.setIcon(medi);
    medio.setSize(40,20);
    medio.setToolTipText("Draws the line from selected point to middle point of selected line");
    medio.setBackground(back);
    medio.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_linea)i,4,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_linea)j,4,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton circu = new JButton() ;
    circu = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    circu.setIcon(circul);
    circu.setSize(40,20);
    circu.setToolTipText("Creates the two point of intersection of two circles");
    circu.setBackground(back);
    circu.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g,p;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc")
				{
				    g= new Objetos_punto((Objetos_mpcircle)i,(Objetos_mpcircle)j,1,Drawing.glist);
				    p= new Objetos_punto((Objetos_mpcircle)i,(Objetos_mpcircle)j,2,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton hexa = new JButton() ;
    hexa = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    hexa.setIcon(hexagon);
    hexa.setSize(40,20);
    hexa.setToolTipText("Creates the regular hexagon being the horizontal radius the line drawn");
    hexa.setBackground(back);
    hexa.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		double x[] = new double[6];
		double y[] = new double[6];
		double r;
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    r=i.xd[1]-i.xd[0];
			    x[0]=i.xd[1];y[0]=i.yd[1];
			    x[1]=x[0]-r*Math.sin(Math.PI/6);
			    y[1]=r*Math.cos(Math.PI/6)+y[0];
			    x[2]=x[1]-r;y[2]=y[1];
			    x[3]=i.xd[0]-r;y[3]=y[0];
			    x[4]=x[2];y[4]=-r*Math.cos(Math.PI/6)+y[0];
			    x[5]=x[1];y[5]=y[4];
			    g= new Objetos_poly(x,y,6,Drawing.glist);
			    i.delete();
			    repaint();
			}
		    }
		}     
	    }
	});

    JButton miarco = new JButton() ;
    miarco = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    miarco.setIcon(arco);
    miarco.setSize(40,20);
    miarco.setToolTipText("Creates th");
    miarco.setBackground(back);
    miarco.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		double x[] = new double[2];
		double y[] = new double[2];
		double r;
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    double x0 = i.xd[0]; double y0=i.yd[0];
			    double x1 = i.xd[1]; double y1=i.yd[1];
			    String teta = Drawing.src32.getText();
			    double t21 = Double.parseDouble(teta);
			    g = new Objetos_arcos(x0,y0,x1,y1,t21,0,Drawing.glist);
			    i.delete();
			    repaint();
			}
		    }
		}     
	    }
	});

    JButton sector = new JButton() ;
    sector = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    sector.setIcon(misector);
    sector.setSize(40,20);
    sector.setToolTipText(" ");
    sector.setBackground(back);
    sector.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		double x[] = new double[2];
		double y[] = new double[2];
		double r;
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    double x0 = i.xd[0]; double y0=i.yd[0];
			    double x1 = i.xd[1]; double y1=i.yd[1];
			    String teta = Drawing.src32.getText();
			    double t21 = Double.parseDouble(teta);
			    g = new Objetos_arcos(x0,y0,x1,y1,t21,2,Drawing.glist);
			    i.delete();
			    repaint();
			}
		    }
		}     
	    }
	});

    JButton penta = new JButton() ;
    penta = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    penta.setIcon(pentagon);
    penta.setSize(40,20);
    penta.setToolTipText("Creates a regular pentagon being the base the horizontal line drawn");
    penta.setBackground(back);
    penta.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		double x[] = new double[5];
		double y[] = new double[5];
		double r;
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    r=i.xd[1]-i.xd[0];
			    x[0]=i.xd[1];y[0]=i.yd[1];
			    x[1]=x[0]+r*Math.cos((Math.PI/180)*72);
			    y[1]=-r*Math.sin((Math.PI/180)*72)+y[0];
			    x[2]=x[0]-r/2;y[2]=y[1]-r*Math.sin((Math.PI/180)*36);
			    x[3]=i.xd[0]-r*Math.cos((Math.PI/180)*72);y[3]=y[1];
			    x[4]=i.xd[0];y[4]=y[0];
			    g= new Objetos_poly(x,y,5,Drawing.glist);
			    i.delete();
			    repaint();
			}
		    }
		}     
	    }
	});


    JButton tria = new JButton() ;
    tria = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tria.setIcon(triangle);
    tria.setSize(40,20);
    tria.setToolTipText("Creates the equilateral triangle being the base the horizontal line drawn");
    tria.setBackground(back);
    tria.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		double x[] = new double[3];
		double y[] = new double[3];
		double r;
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    r=i.xd[1]-i.xd[0];
			    x[0]=i.xd[1];y[0]=i.yd[1];
			    x[1]=x[0]-r/2.;
			    y[1]=-r*Math.cos(Math.PI/6)+y[0];
			    x[2]=i.xd[0];y[2]=i.yd[0];
			    g= new Objetos_poly(x,y,3,Drawing.glist);
			    i.delete();
			    repaint();
			}
		    }
		}     
	    }
	});

    JButton inters = new JButton() ;
    inters = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    inters.setIcon(inter);
    inters.setSize(40,20);
    inters.setToolTipText("Draws the intersected point between two selected lines");
    inters.setBackground(back);
    inters.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new Objetos_punto((Objetos_linea)j,(Objetos_linea)i, 3, Drawing.glist);

				}
			}
		    }     
		}
	    }
	});

    JButton foco = new JButton() ;
    foco = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    foco.setIcon(focos);
    foco.setSize(40,20);
    foco.setToolTipText("Draws the two focus point of an elipse");
    foco.setBackground(back);
    foco.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
		      g= new Objetos_punto((Objetos_oval)i,1, Drawing.glist);
		      j= new Objetos_punto((Objetos_oval)i,2, Drawing.glist);
		      repaint();
			}
		    }
		}     
	    }
	});

    JButton eje = new JButton() ;
    eje = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    eje.setIcon(ejes);
    eje.setSize(40,20);
    eje.setToolTipText("Draws the two axis of an elipse");
    eje.setBackground(back);
    eje.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
		      g= new Objetos_linea((Objetos_oval)i,1, Drawing.glist);
		      j= new Objetos_linea((Objetos_oval)i,2, Drawing.glist);
		      repaint();
			}
		    }
		}     
	    }
	});


    JButton contro = new JButton() ;
    contro = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    contro.setIcon(control);
    contro.setSize(40,20);
    contro.setToolTipText("Draws the Bezier curve that uses as control points the four given points.");
    contro.setBackground(back);
    contro.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		double x[] = new double[4];
		double y[] = new double[4];
		Objetos i,j,k,l,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
			    for(k=j.next;k!=null;k=k.next)
				if(k.select==1 && k.nombre=="pu")
				{
			    for(l=k.next;l!=null;l=l.next)
				if(l.select==1 && l.nombre=="pu")
				{
				    x[0]=i.xd[0];y[0]=i.yd[0];
				    x[1]=j.xd[0];y[1]=j.yd[0];
				    x[2]=k.xd[0];y[2]=k.yd[0];
				    x[3]=l.xd[0];y[3]=l.yd[0];
				    //  g= new Objetos_bezier(x,y,4,black, Drawing.glist);
		      g=new Objetos_bezier((Objetos_punto)i,(Objetos_punto)j,(Objetos_punto)k,(Objetos_punto)l,Drawing.glist);
		      repaint();
			}
		    }
		}     
	    }
		    }
		}
	    }
	});


    JButton mediatriz = new JButton() ;
    mediatriz = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    mediatriz.setIcon(atriz);
    mediatriz.setSize(40,20);
    mediatriz.setToolTipText("Draws the perpendicular to a selected line in the middle");
    mediatriz.setBackground(back);
    mediatriz.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
				    g= new Objetos_linea((Objetos_linea)i, 5, Drawing.glist);
				    repaint();
			}
		    }     
		}
	    }
	});


JButton bisec = new JButton() ;
bisec = new DoubleBorderedButton(
new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
bisec.setIcon(bis);
bisec.setSize(40,20);
bisec.setToolTipText("Draws the line that bisecs two selected lines from the side of two selected points.");
bisec.setBackground(back);
bisec.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent evt){
	Objetos i,j,k,l,g;
	for(i=Drawing.glist.ghead;i!=null;i=i.next){
	    if(i.select==1 && i.nombre=="li")
	    {
		    for(j=i.next;j!=null;j=j.next)
			if(j.select==1 && j.nombre=="li"){
			    for(k=Drawing.glist.gtail;k!=null;k=k.prev){
				if(k.select==1 && k.nombre=="pu")
				{
					for(l=k.prev;l!=null;l=l.prev)
					    if(l.select==1 && l.nombre=="pu"){
						g= new Objetos_linea((Objetos_linea)j,(Objetos_linea)i,(Objetos_punto)k,(Objetos_punto)l,6,Drawing.glist);
						repaint();
					    }
				    }
				}
			    }
			}
		}
    }
});

    JButton paral = new JButton() ;
    paral = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    paral.setIcon(paralela);
    paral.setSize(40,20);
    paral.setToolTipText("Draws a line parallel to another trough a given central point.");
    paral.setBackground(back);
    paral.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt){
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu"){
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_linea)i, 3, Drawing.glist);
				    repaint();
				}
			}

			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_linea)j, 3, Drawing.glist);
				    repaint();
				}
			}
		    }
		}
	    }
	});


    JButton tgri = new JButton() ;
    final Color green = new Color(0,255,0);
    tgri = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgri.setIcon(tgright);
    tgri.setSize(40,20);
    tgri.setToolTipText("Draws the tangent from selected point to a circle in clockwise direction");
    tgri.setBackground(back);
    tgri.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g; Objetos_punto p;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_mpcircle)i,7,1,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_mpcircle)j,7,1,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tglf = new JButton() ;
    tglf = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tglf.setIcon(tgleft);
    tglf.setSize(40,20);
    tglf.setToolTipText("Draws the tangent from selected point to a circle in anti-clockwise direction");
    tglf.setBackground(back);
    tglf.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_mpcircle)i,7,2,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_mpcircle)j,7,2,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tgov1 = new JButton() ;
    tgov1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgov1.setIcon(tgoval1);
    tgov1.setSize(40,20);
    tgov1.setToolTipText("Draws the tangent from selected point to an oval in anti-clockwise direction");
    tgov1.setBackground(back);
    tgov1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_oval)i,8,1,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_oval)j,8,1,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton tgov2 = new JButton() ;
    tgov2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    tgov2.setIcon(tgoval2);
    tgov2.setSize(40,20);
    tgov2.setToolTipText("Draws the tangent from selected point to an oval in anti-clockwise direction");
    tgov2.setBackground(back);
    tgov2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_oval)i,8,2,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new Objetos_linea((Objetos_punto)i,(Objetos_oval)j,8,2,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton twopo = new JButton() ;
    twopo = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    twopo.setIcon(twopoint);
    twopo.setSize(40,20);
    twopo.setToolTipText("Draws the segment between two selected points.");
    twopo.setBackground(back);
    twopo.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_linea((Objetos_punto)j,(Objetos_punto)i,1,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton onelin = new JButton() ;
    onelin = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    onelin.setIcon(onelinint);
    onelin.setSize(40,20);
    onelin.setToolTipText("Draws the two limit points of a selected line.");
    onelin.setBackground(back);
    onelin.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    j= new Objetos_punto((Objetos_linea)i, 2, 1, Drawing.glist);
			    g= new Objetos_punto((Objetos_linea)i, 2, 2, Drawing.glist);
			    repaint();
			}
		    }     
		}
	    }
	});

    JButton middle = new JButton() ;
    middle = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    middle.setIcon(middpoint);
    middle.setSize(40,20);
    middle.setToolTipText("Draws the middle point of a selected line.");
    middle.setBackground(back);
    middle.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="li")
			{
			    j= new Objetos_punto((Objetos_linea)i, 1, 1, Drawing.glist);
			    repaint();
			}
		    }     
		}
	    }
	});

    JButton twcir = new JButton() ;
    twcir = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    twcir.setIcon(twocir);
    twcir.setSize(40,20);
    twcir.setToolTipText("Draws a spiral-circle using two selected points.");
    twcir.setBackground(back);
    twcir.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="pu")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="pu")
				{
				    g= new Objetos_mpcircle((Objetos_punto)j,(Objetos_punto)i,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton cor1 = new JButton() ;
    cor1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    cor1.setIcon(cort1);
    cor1.setSize(40,20);
    cor1.setToolTipText("Creates the first point of intersection between selected line & spiral-circle");
    cor1.setBackground(back);
    cor1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new Objetos_punto((Objetos_mpcircle)i, (Objetos_linea)j, 5, 1, Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new Objetos_punto((Objetos_mpcircle)j, (Objetos_linea)i, 5, 1, Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});


    JButton centr = new JButton() ;
    centr = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    centr.setIcon(center);
    centr.setSize(40,20);
    centr.setToolTipText("Creates the point center of a selected spiral-circle");
    centr.setBackground(back);
    centr.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    g= new Objetos_punto((Objetos_mpcircle)i, 4, Drawing.glist);
			    repaint();
			}
		    }
		}     
	    }
	});


    JButton cor2 = new JButton() ;
    cor2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    cor2.setIcon(cort2);
    cor2.setSize(40,20);
    cor2.setToolTipText("Creates the second point of intersection between selected line & spiral-circle");
    cor2.setBackground(back);
    cor2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="mpc")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new Objetos_punto((Objetos_mpcircle)i,(Objetos_linea)j, 5, 2, Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="mpc"){
				    g= new Objetos_punto((Objetos_mpcircle)j,(Objetos_linea)i, 5, 2, Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton corov1 = new JButton() ;
    corov1 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    corov1.setIcon(intel);
    corov1.setSize(40,20);
    corov1.setToolTipText("Creates the first point of intersection between selected line & oval");
    corov1.setBackground(back);
    corov1.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new Objetos_punto((Objetos_oval)i,(Objetos_linea)j,6,1,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new Objetos_punto((Objetos_oval)j,(Objetos_linea)i,6,1,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});

    JButton corov2 = new JButton() ;
    corov2 = new DoubleBorderedButton(
	new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
    corov2.setIcon(intel2);
    corov2.setSize(40,20);
    corov2.setToolTipText("Creates the second point of intersection between selected line & oval");
    corov2.setBackground(back);
    corov2.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent evt) {
		Objetos i,j,g;
		for(i=Drawing.glist.ghead;i!=null;i=i.next){
		    if(i.select==1)
		    {
			if(i.nombre=="ov")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="li")
				{
				    g= new Objetos_punto((Objetos_oval)i,(Objetos_linea)j,6,2,Drawing.glist);
				    repaint();
				}
			}
			else if(i.nombre=="li")
			{
			    for(j=i.next;j!=null;j=j.next)
				if(j.select==1 && j.nombre=="ov"){
				    g= new Objetos_punto((Objetos_oval)j,(Objetos_linea)i,6,2,Drawing.glist);
				    repaint();
				}
			}
		    }     
		}
	    }
	});


    getContentPane().add(newtool);

    newtool.add(twopo);
    newtool.add(middle);
    newtool.add(onelin);
    newtool.add(mediatriz);
    newtool.add(perp);
    newtool.add(paral);
    newtool.add(medio);
    newtool.add(inters);
    newtool.add(bisec);
    newtool.add(twcir);
    newtool.add(centr);
    newtool.add(centroval);
    newtool.add(cor1);
    newtool.add(cor2);
    newtool.add(tgri);
    newtool.add(tglf);
    newtool.add(corov1);
    newtool.add(corov2);
    newtool.add(tgov1);
    newtool.add(tgov2);
    newtool.add(foco);
    newtool.add(eje);
    newtool.add(contro);
    newtool.add(hexa);
    newtool.add(tria);
    newtool.add(penta);
    newtool.add(miarco);
    newtool.add(sector);
    newtool.add(mitrazo);
    newtool.add(mitr);
    newtool.add(mi4pun);
    newtool.add(mi4med);
    newtool.add(circu);
    newtool.add(pintar);
    newtool.add(midis);
    newtool.add(dispto);
    newtool.add(cte);
    newtool.add(miscoor);


    pack();
    setVisible(false);
 }    
    Icon ppinta = new ImageIcon("images/puntopinta.png");
    Icon midis = new ImageIcon("images/distancia.png");
    Icon dispto = new ImageIcon("images/dispunto.png");
    Icon centroval = new ImageIcon("images/centrovalo.png");
    Icon miscoor = new ImageIcon("images/coor.png");
    Icon cte = new ImageIcon("images/constante.png");
			      
  public void ang_rec(Objetos_bezicirc bez, Objetos_punto pp1, Objetos_punto pp2) {
      double xd0,xd1,xd2,xd3,yd0,yd1,yd2,yd3,w,tet1,tet2,tet21,d=0;
      double pi = Math.PI;
      b1=bez;
      xd1=pp1.xd[0]; xd2=pp2.xd[0];
      yd1=pp1.yd[0]; yd2=pp2.yd[0];
      xd0=(b1.xd[1]+b1.xd[0])/2;
      yd0=(b1.yd[1]+b1.yd[0])/2;
      w=(double)b1.w;
      tet1 = Math.atan2((yd0-yd1),(xd1-xd0)) ; 
      if(tet1<0)tet1+=2*pi;
      tet2 = Math.atan2((yd0-yd2),(xd2-xd0)) ;
      if(tet2<0)tet2+=2*pi;
      if(tet2<tet1)tet2+=2*pi;
      tet21= tet2-tet1;
      ar1 = new Objetos_arcos(xd0,yd0,xd1,yd1,tet21*180/pi,d,Drawing.glist);
      ar2 = new Objetos_arcos(xd0,yd0,xd2,yd2,360-tet21*180/pi,d,Drawing.glist);
  }

  public void ang_ova(Objetos_oval oov, Objetos_punto pp1, Objetos_punto pp2) {
      double xv0,xv1,xv2,xv3,yv0,yv1,yv2,yv3,tet1,tet2,tet21,d;
      double pi = Math.PI;
      xv1=pp1.xd[0]; xv2=pp2.xd[0];
      yv1=pp1.yd[0]; yv2=pp2.yd[0];
      xv0=(oov.xd[0]+oov.xd[1]+oov.xd[2]+oov.xd[3])/4.;
      yv0=(oov.yd[0]+oov.yd[1]+oov.yd[2]+oov.yd[3])/4.;
      d=(oov.xd[1]-oov.xd[0])-(oov.yd[1]-oov.yd[0]);
      tet1 = Math.atan2((yv0-yv1),(xv1-xv0)) ; 
      if(tet1<0)tet1+=2*pi;
      tet2 = Math.atan2((yv0-yv2),(xv2-xv0)) ;
      if(tet2<0)tet2+=2*pi;
      if(tet2<tet1)tet2+=2*pi;
      tet21= tet2-tet1;
      ar1 = new Objetos_arcos(xv0,yv0,xv1,yv1,tet21*180/pi,d,Drawing.glist);
      ar2 = new Objetos_arcos(xv0,yv0,xv2,yv2,360-tet21*180/pi,d,Drawing.glist);
  }

}




			     

