/**
 * Metagraf.java
 *
 *
 * Created: Wed Apr 26 16:57:42 2000
 *
 * @author Santiago Muelas
 * @version
 */

import java.awt.*;
import java.awt.event.* ;
import javax.swing.*;
import javax.swing.border.*;

public class Metagraf
{
    static Dimension screen;
    static JWindow splash;
    public static void main(String args[])
    {
	//***********************************************************
	//      PARA LOS IMPACIENTES
	//***********************************************************

	splash = new JWindow();
	JPanel anuncio = (JPanel)splash.getContentPane();
	int wd = 400;
	int ht = 318;
	screen = Toolkit.getDefaultToolkit().getScreenSize();
	int x = (screen.width-wd)/2;
	int y = (screen.height-ht)/2;
	splash.setBounds(x,y,wd,ht);
	JLabel titulo = new JLabel(new ImageIcon("images/splash.png"));
	JLabel mensaje = new JLabel
	    ("METAGRAF is a Free Software Product ( author: S. Muelas )", JLabel.CENTER);
	titulo.setBorder(new BevelBorder(BevelBorder.RAISED));
	mensaje.setBorder(new BevelBorder(BevelBorder.RAISED));
	anuncio.add(titulo, BorderLayout.CENTER);
	anuncio.add(mensaje, BorderLayout.SOUTH);
	anuncio.setBorder(new BevelBorder(BevelBorder.LOWERED));
	anuncio.setBorder(BorderFactory.createLineBorder(new Color(0,0,0), 1));
	splash.setVisible(true);
	
	//********************************************************************
	new mg2() ;//PROGRAMA PRINCIPAL
	//********************************************************************
	
	try { Thread.sleep(500); } catch (Exception e) {}
	splash.setVisible(false);
    }
}

class mg2
{
  static int WIDTH = 970;
  static int HEIGHT = 968 ;
  Color lblue = new Color(100,100,150);
  Color dblue = new Color(210,210,210);
  Color white = new Color(255,255,255);
  Color lyellow = new Color(225,225,225);
  JTextArea texto = new JTextArea("");
  static JTextField tit1, tit;
  JSlider dslH1;
  JButton help,mpedit,viewM,sig,pst,estado,curvtex,rotax,chcoord,xx2,xx4,div;
  JPanel mensa, axes;
  static JPanel cnx;
  mpeditor mpedi = new mpeditor(texto);
  chooseArrow panelflechas = new chooseArrow();
  chooseTxppar datostxp = new chooseTxppar();
  imatot foto = new imatot();
  static CustomScrollPane sp;
  static Drawing da;
  static Tools tb;
  static Conexiona Conex = new Conexiona();
  Icon abre = new ImageIcon("images/ver.png");
  Icon nover = new ImageIcon("images/nover.png");
  
  public mg2()
  {
    JFrame ventana = new JFrame("METAGRAF-2") ;
	ventana.addWindowListener( new Conclusion() );
	ventana.getContentPane().setLayout(new BorderLayout(2,2));
	ventana.setBackground(white);
	if(Metagraf.screen.height < HEIGHT){ HEIGHT= Metagraf.screen.height;  }
	if(Metagraf.screen.width < WIDTH){ WIDTH= Metagraf.screen.width;  }
	
        cnx = Conex.newtool;
        cnx.setBorder(new BevelBorder(BevelBorder.LOWERED));
	cnx.setSize(54,540);
	cnx.setVisible(false);

	tb = new Tools();
	tb.setLayout(new GridLayout(17,2));
	tb.setBorder(new BevelBorder(BevelBorder.LOWERED));
	tb.setSize(54,540);
	tb.setBackground(new Color(210,210,210));

	da = new Drawing(tb, texto, mpedi, panelflechas, datostxp, foto);
        da.setBorder(new BevelBorder(BevelBorder.LOWERED));
	tit=da.newtext;
	mensa=da.inform;
	dslH1=da.desliza1;
	sig=da.signo;
	mpedit=da.mpedicion;
	viewM=da.mouse_screen;
	pst=da.ps_tex;
	curvtex=da.text_path;
	estado=da.reset;
	rotax=da.selax;
	xx2=da.sigpor2;
	xx4=da.sigpor4;
	div=da.div2;
	mensa.setVisible(false);
		
	JPanel botones = new JPanel();
	botones.setLayout(new GridLayout(4,1));
	botones.setBorder(new BevelBorder(BevelBorder.LOWERED));
	botones.setSize(40,60);
	botones.add(sig);
	botones.add(xx2);
	botones.add(xx4);
	botones.add(div);

	JPanel miboton = new JPanel();
	miboton.setLayout(new BorderLayout(1,1));
	miboton.setBorder(new BevelBorder(BevelBorder.LOWERED));
	miboton.setSize(40,40);
	final JButton ver = new JButton();
	ver.setIcon(abre);
        ver.setSize(24,24);
        ver.setBorder(new BevelBorder(BevelBorder.RAISED));
        ver.setToolTipText("Abre o cierra el Panel de Control");
        ver.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ezoom)
	  {if(mensa.isVisible()){mensa.setVisible(false);ver.setIcon(abre);}
	  else {mensa.setVisible(true);ver.setIcon(nover);}}});
	miboton.add(ver);
	Font fancy1 = new Font("Sanserif", Font.BOLD, 18);
	JPanel titul = new JPanel();
	titul.setLayout(new BorderLayout(1,1));
	titul.setBorder(new BevelBorder(BevelBorder.RAISED));
	titul.setSize(884,40);
	titul.setBackground(new Color(210,210,210));
	titul.add(tit);

	JPanel title = new JPanel();
	title.setLayout(new BorderLayout(1,1));
	title.setSize(884,40);
	title.add(titul);

	JPanel deslizar = new JPanel();
	Font gradFont = new Font("Sanserif", Font.BOLD, 6);
	deslizar.setLayout(new BorderLayout(1,1));
	deslizar.setSize(930,20);
	deslizar.add("Center",dslH1);
	deslizar.add("East",miboton);

	JPanel desli = new JPanel();
	desli.setLayout(new BorderLayout(5,5));
	desli.setBorder(new BevelBorder(BevelBorder.RAISED));
	desli.setSize(930,20);
	desli.add("Center",deslizar);
	
	JPanel tools1 = new JPanel();
	tools1.setLayout(new FlowLayout());
	tools1.setBorder(new BevelBorder(BevelBorder.RAISED));
	tools1.add("Center",title);

	JPanel tools = new JPanel();
	tools.setLayout(new BorderLayout(3,1));
	tools.add("North",tools1);
	tools.add("Center",desli);

	JPanel norte = new JPanel();
	norte.setLayout(new BorderLayout(1,1));
	norte.setSize(950,60);
	norte.add("East",botones);
	norte.add("Center",tools);

	JPanel mensajes = new JPanel();
	mensajes.setLayout(new BorderLayout(1,1));
	mensajes.setBorder(new BevelBorder(BevelBorder.RAISED));
	mensajes.add("Center",mensa);

	JPanel aleste = new JPanel();
	aleste.setLayout(new BorderLayout(1,1));
	aleste.add("West",mensajes);

	sp = new CustomScrollPane(da);

	JPanel mitolbox = new JPanel();
	mitolbox.setLayout(new BorderLayout(3,1));
		mitolbox.setBorder(new BevelBorder(BevelBorder.RAISED));
	mitolbox.setSize(54,680);
	mitolbox.add("North",tb.set);
	mitolbox.add("Center",tb);

	JPanel tolbox = new JPanel();
	tolbox.setLayout(new BorderLayout(3,1));
	tolbox.setBorder(new BevelBorder(BevelBorder.RAISED));
	tolbox.setSize(54,680);
	tolbox.add("East",mitolbox);
	tolbox.add("West",cnx);

	ventana.getContentPane().add("East",aleste);
	ventana.getContentPane().add("West",tolbox);
	ventana.getContentPane().add("North",norte);
	ventana.getContentPane().add(sp, BorderLayout.CENTER);
	ventana.setSize(WIDTH,HEIGHT) ;
	ventana.setVisible(true);
    }
}


class Conclusion extends WindowAdapter
{
  public void windowClosing( WindowEvent evt )
  {
    System.exit(0);
  }
}




