import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//**************************************************************************

class Objetos_oval extends Objetos

//**************************************************************************
{
    static final long serialVersionUID = 5467697011527664336L;
  Color c;
  boolean transf=false;
  int x0,y0,x1,y1,w,h;
  double a,b,exi,emi,foc,xf1,yf1,xf2,yf2,alfa=0, alfa_old=0;
  float xn0,xn1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
  float yn0,yn1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;

    Objetos_oval(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	nombre="ov";
	select = 5;
    }

    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,5);
	transf=true;
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	int x = x0;
	int y = y0;
	w = x1-x0;
	h = y1-y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;
	if(w<0) w = -w;
	if(h<0) h = -h;
	if(ijk==0){
	xd[0]=(double)x0;yd[0]=(double)y0;xd[1]=(double)x1;yd[1]=(double)y1;
	xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];xd[4]=(double)((xd[0]+xd[1])/2+(xd[1]-xd[2])/4);yd[4]=(double)((yd[0]+yd[1])/2);
	}
	x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	xc = (xd[0]+xd[1]+xd[2]+xd[3])/4.;
	yc = (yd[0]+yd[1]+yd[2]+yd[3])/4.;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	GeneralPath rectan = new GeneralPath();
	rectan.moveTo((float)xd[0],(float)yd[0]);
	rectan.lineTo((float)xd[3],(float)yd[3]);	
	rectan.lineTo((float)xd[1],(float)yd[1]);	
	rectan.lineTo((float)xd[2],(float)yd[2]);	
	rectan.closePath();
	forma[0] = (Shape) rectan;

	GeneralPath elip = daForma(xd[0],xd[1],xd[2],xd[3],yd[0],yd[1],yd[2],yd[3]);
	forma[1] = (Shape)elip; 

	if (select != 0)
	{
	    g2.setColor(Color.red);
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    g2.draw(forma[0]);
	    g2.draw(forma[1]);
	    g2.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
	    g2.fillRect((int)xd[2]-1,(int)yd[2]-1,3,3);
	    g2.fillRect((int)xd[3]-1,(int)yd[3]-1,3,3);
	    g2.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    if(transf==false){
	    g2.setColor(Color.blue);
	    g2.drawLine((int)xc,(int)yc,(int)xd[4],(int)yd[4]);
	    g2.fillRect((int)xd[4]-1,(int)yd[4]-1,3,3);
	    g2.drawOval((int)xd[4]-3,(int)yd[4]-3,7,7);
	    g2.fillRect((int)xc-1,(int)yc-1,3,3);
	    int angulo = (int)(alfa*180/pi);
	    Drawing.src32.setText("teta="+angulo);
	    }
	}

	if (select == 0 )
	    {
		stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		if(refill==1)
		    {
			g2.setColor(cc); 
			g2.fill(forma[1]);
		    }
		g2.setColor(cl);
		g2.draw(forma[1]);
	    }
	
	rc=new Rectangle(xsel-5,ysel-5,11,11);
        if(g2.hit(rc,forma[1],true)) inters=true;
	else inters=false;
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	g2.setColor(cl);
    }

    public void metapost (BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	if(refill==1)
	    {
		cr = (float)cc.getRed()/255f;
		cv = (float)cc.getGreen()/255f;
		ca = (float)cc.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");
	

	float xx0=(float)(xd[0]/uesc), xx1=(float)(xd[1]/uesc), xx2=(float)(xd[2]/uesc), xx3=(float)(xd[3]/uesc), yy0=(float)(yd[0]/uesc), yy1=(float)(yd[1]/uesc), yy2=(float)(yd[2]/uesc), yy3=(float)(yd[3]/uesc);
	float x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
	float y0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float xh=cte*wh/20; float xv=cte*wv/20;
	float yh=cte*hh/20; float yv=cte*hv/20;
	x0=(xx2+xx0)/20;x3=(xx0+xx3)/20;x6=(xx3+xx1)/20;x9=(xx1+xx2)/20;
	y0=(yy2+yy0)/20;y3=(yy0+yy3)/20;y6=(yy3+yy1)/20;y9=(yy1+yy2)/20;
	x1=x0-xv; x11=x0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	y1=y0-yv; y11=y0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	float ym1=118f-y1;float ym2=118f-y2;float ym3=118f-y3;
	float ym4=118f-y4;float ym5=118f-y5;float ym6=118f-y6;
	float ym7=118f-y7;float ym8=118f-y8;float ym9=118f-y9;
	float ym10=118f-y10;float ym11=118f-y11;float ym0=118f-y0;
	out.write("("+x0+"u,"+ym0+"u).. controls ("+x1+"u,"+ym1+"u) and ("+x2+"u,"+ym2+"u)..("+x3+"u,"+ym3+"u).. controls ("+x4+"u,"+ym4+"u) and ("+x5+"u,"+ym5+"u)..("+x6+"u,"+ym6+"u).. controls ("+x7+"u,"+ym7+"u) and ("+x8+"u,"+ym8+"u)..("+x9+"u,"+ym9+"u).. controls ("+x10+"u,"+ym10+"u) and ("+x11+"u,"+ym11+"u)..("+x0+"u,"+ym0+"u) .. cycle;\n");
		if(text_on_path==false)
		    {
			if(refill==1) out.write( "fill a withcolor col;\n" ); 
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			    {
				out.write("draw a withcolor loc ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
			    }
			else
			    {
				out.write("draw a ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
			    }
		    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }

    public void moveobj(int x,int y)
    {
	if(ijk==0)
	    {
		for(int i=0;i<5;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y; }
		x1 += x;
		x0 += x;
		y1 += y;
		y0 += y;
		if(x0<x1) { xmin = x0-2 ; xmax = x1+2 ; }
		else      { xmin = x1-2 ; xmax = x0+2 ; }
		if(y0<y1) { ymin = y0-2 ; ymax = y1+2 ; }
		else      { ymin = y1-2 ; ymax = y0+2 ; }
	    }
	if(ijk!=0)
	    {
		xmin=100000;xmax=-100000;ymin=100000;ymax=-100000;
		for(int i=0;i<5;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y;                       
			if(xmin>(int)xd[i]-2) xmin=(int)xd[i]-2;
			if(xmax<(int)xd[i]+2) xmax=(int)xd[i]+2;
			if(ymin>(int)yd[i]-2) ymin=(int)yd[i]-2;
			if(ymax<(int)yd[i]+2) ymax=(int)yd[i]+2;
		    }
	    }
    }

    public void movepoint(int x,int y)
    {
	if(ijk==0)
	    {
		if(select==6)ijk=1;
		if(select==5 || select==3)x1 += x; 
		if(select==4 || select==2)x0 += x;
		if(select==5 || select==4)y1 += y;
		if(select==3 || select==2)y0 += y;
		if(x0<x1) { xmin = x0-1 ; xmax = x1+1 ; }
		else      { xmin = x1-1 ; xmax = x0+1 ; }
		if(y0<y1) { ymin = y0-1 ; ymax = y1+1 ; }
		else      { ymin = y1-1 ; ymax = y0+1 ; }
	    }
	else
	    {
		double xx, yy;
		xx=(double)x; yy=(double)y;
		if(select==6){xd[4]+=(double)x;yd[4]+=(double)y;girar();}
		if(select==5)reescal(xx,yy,1);
		if(select==4)reescal(xx,yy,2);
		if(select==3)reescal(xx,yy,3);
		if(select==2)reescal(xx,yy,0);
		xmin=100000;xmax=-100000;ymin=100000;ymax=-100000;
		for(int k=0; k<5; k++) {
		if(xmin>xd[k])xmin=(int)(xd[k]-2);
		if(ymin>yd[k])ymin=(int)(yd[k]-2);
		if(xmax<xd[k])xmax=(int)(xd[k]+2);
		if(ymax<yd[k])ymax=(int)(yd[k]+2);
		}
	    }
    }

    public boolean selectpoint(int x,int y)
    {
	double xx, yy;
	xx=(double)x; yy=(double)y;

	if((x-x0<5 && x-x0>-5 && y-y0<5 && y-y0>-5) || (xx-xd[0]<5. && xx-xd[0]>-5. && yy-yd[0]<5. && yy-yd[0]>-5.))
	    {
		select = 2;
		return(true);
	    }
	if((x-x1<5 && x-x1>-5 && y-y0<5 && y-y0>-5) || (xx-xd[3]<5. && xx-xd[3]>-5. && yy-yd[3]<5. && yy-yd[3]>-5.))
	    {
		select = 3;
		return(true);
	    }
	if((x-x0<5 && x-x0>-5 && y-y1<5 && y-y1>-5) || (xx-xd[2]<5. && xx-xd[2]>-5. && yy-yd[2]<5. && yy-yd[2]>-5.))
	    {
		select = 4;
		return(true);
	    }
	if((x-x1<5 && x-x1>-5 && y-y1<5 && y-y1>-5) || (xx-xd[1]<5. && xx-xd[1]>-5. && yy-yd[1]<5. && yy-yd[1]>-5.))
	    {
		select = 5;
		return(true);
	    }
	if((xx-xd[4]<5. && xx-xd[4]>-5. && yy-yd[4]<5. && yy-yd[4]>-5.))
	    {
		select = 6;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public GeneralPath daForma(double px0, double px1, double px2, double px3, double py0, double py1, double py2, double py3)
    {
	float xx0=(float)px0, xx1=(float)px1, xx2=(float)px2, xx3=(float)px3, yy0=(float)py0, yy1=(float)py1, yy2=(float)py2, yy3=(float)py3;
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float xh=cte*wh/2; float xv=cte*wv/2;
	float yh=cte*hh/2; float yv=cte*hv/2;
	xn0=(xx2+xx0)/2;x3=(xx0+xx3)/2;x6=(xx3+xx1)/2;x9=(xx1+xx2)/2;
	yn0=(yy2+yy0)/2;y3=(yy0+yy3)/2;y6=(yy3+yy1)/2;y9=(yy1+yy2)/2;
	xn1=xn0-xv; x11=xn0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	yn1=yn0-yv; y11=yn0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	a= Math.sqrt((xn0-xc)*(xn0-xc)+(yn0-yc)*(yn0-yc));
	b= Math.sqrt((x3-xc)*(x3-xc)+(y3-yc)*(y3-yc));
	if(a>=b)
	{
	    exi=a; emi=b;
	    foc=a-Math.sqrt(a*a-b*b);
	    xf1=xc+((a-foc)/a)*(x6-xc);
	    yf1=yc+((a-foc)/a)*(y6-yc);
	    xf2=xc+((a-foc)/a)*(xn0-xc);
	    yf2=yc+((a-foc)/a)*(yn0-yc);
	}
	else
	{
	    exi=b; emi=a;
	    foc=b-Math.sqrt(b*b-a*a);
	    xf1=xc+((b-foc)/b)*(x9-xc);
	    yf1=yc+((b-foc)/b)*(y9-yc);
	    xf2=xc+((b-foc)/b)*(x3-xc);
	    yf2=yc+((b-foc)/b)*(y3-yc);
	}

	GeneralPath elipse = new GeneralPath();
	elipse.moveTo(xn0,yn0);
	elipse.curveTo(xn1,yn1,x2,y2,x3,y3);
	elipse.curveTo(x4,y4,x5,y5,x6,y6);
	elipse.curveTo(x7,y7,x8,y8,x9,y9);
	elipse.curveTo(x10,y10,x11,y11,xn0,yn0);
	return(elipse);
    }

    public void reescal(double x, double y, int nodo)
    {
	double xp, yp, alfa, s, c, xcc, ycc;
	alfa=Math.atan((yd[3]-yd[0])/(xd[3]-xd[0]));
	s=Math.sin(alfa); c=Math.cos(alfa);
	xp=x*c+y*s;
	yp=-x*s+y*c;
	xd[nodo]+=x;yd[nodo]+=y;
	if(nodo==0){
	xd[3]-=yp*s;
	yd[3]+=yp*c;
	xd[2]+=xp*c;
	yd[2]+=xp*s;
	}
	if(nodo==1){
	xd[2]-=yp*s;
	yd[2]+=yp*c;
	xd[3]+=xp*c;
	yd[3]+=xp*s;
	}
	if(nodo==2){
	xd[1]-=yp*s;
	yd[1]+=yp*c;
	xd[0]+=xp*c;
	yd[0]+=xp*s;
	}
	if(nodo==3){
	xd[0]-=yp*s;
	yd[0]+=yp*c;
	xd[1]+=xp*c;
	yd[1]+=xp*s;
	}
	xcc=(xd[0]+xd[1])/2; ycc=(yd[0]+yd[1])/2;
	xd[4]+=xcc-xc;yd[4]+=ycc-yc;
	return;
    }

    public void girar() 
    {
	double xp, yp, s, c;
	alfa_old=alfa;
	alfa=Math.atan((yd[4]-yc)/(xd[4]-xc));
	s=Math.sin(alfa-alfa_old); c=Math.cos(alfa-alfa_old);
	for(int i=0; i<4; i++){
	xp=(xd[i]-xc)*c-(yd[i]-yc)*s+xc;
	yp=(xd[i]-xc)*s+(yd[i]-yc)*c+yc;
	xd[i]=xp;yd[i]=yp;
	}
    }
}
