import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//***********************************************************************

class Objetos_axis extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 8635463045143407062L;
    Color c,cl;
    int x0,y0,x1,y1,z0,z1;
    int n, ikk=0;
    Objetos_axis(int xx0,int yy0,Color cc,Objetos_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    /*
    public void create(double a, double b, double d)
    {
	double aa=a; double bb=b; double dd=d;
	x0=y0=z0=0;
	xd[1]=500*aa/Math.sqrt(aa*aa+bb*bb+dd*dd);
	yd[1]=500*bb/Math.sqrt(aa*aa+bb*bb+dd*dd);
	zd[1]=500*dd/Math.sqrt(aa*aa+bb*bb+dd*dd);
        x1=(int)(xd[1]+0.49);
	y1=(int)(yd[1]+0.49);
	z1=(int)(zd[1]+0.49);
    }
    */
    public void transform(double xc, double yc, double zc)
    {
	ikk=1;
	modi(xc,yc,zc,n);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
    }

    public void paint(Graphics g) 
    {
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = true;
	if(ikk==0){xd[0]=(double)x0;xd[1]=(double)x1;yd[0]=(double)y0;yd[1]=(double)y1;}
	setminmax();
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	int x = (int)xd[0];
	int y = (int)yd[0];
	if(x>(int)xd[1]) x = (int)xd[1];
	if(y>(int)yd[1]) y = (int)yd[1];
	float strokeThickness = thickness;
	g.setColor(new Color(230,230,230));
	BasicStroke stroke = new BasicStroke(strokeThickness);
	if(select!=0) g2.drawString("   "+thickness,843,270);
	g2.setStroke(stroke);

	if(select!=0)
      	    {
		g.setColor(Color.blue);
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
		x0=(int)xd[0];x1=(int)xd[1];y0=(int)yd[0];y1=(int)yd[1];
		g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
		g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);

		double xax = (int)xd[1]-(int)xd[0];
		double yax = (int)yd[1]-(int)yd[0];
		double zax = (int)zd[1]-(int)zd[0];
		double mod = Math.sqrt(xax*xax+yax*yax+zax*zax);
		nx1 = xax/mod;
		nx2 = yax/mod;
		nx3 = zax/mod;
		XX0=(int)xd[0]; YY0=(int)yd[0]; ZZ0=(int)zd[0];
	    }
	    
	else
	    {
		g.setColor(new Color(35,221,100));
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
		x0=(int)xd[0];x1=(int)xd[1];y0=(int)yd[0];y1=(int)yd[1];
	    }
	g.setColor(new Color(0,0,0));
}

public void metapost(BufferedWriter out) 
{
}

public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	for(int i=0;i<2;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
	    }
    }

    public void moveobj(int xx,int yy)
    {
	x0 += xx; xd[0] += (double)xx;
	y0 += yy; yd[0] += (double)yy;
	x1 += xx; xd[1] += (double)xx;
	y1 += yy; yd[1] += (double)yy;
	setminmax();
    }
    public void movepoint(int x,int y)
    {
	if(select==3){ x1 += x;y1 += y; xd[1] += (double)x; yd[1] += (double)y;}
	if(select==2){ x0 += x;y0 += y; xd[0] += (double)x; yd[0] += (double)y;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	if(xx-(int)xd[0]<3 && xx-(int)xd[0]>-3 && yy-(int)yd[0]<3 && yy-yd[0]>-3)
	    {
		select = 2;
		return(true);
	    }
	if(xx-(int)xd[1]<3 && xx-(int)xd[1]>-3 && yy-(int)yd[1]<3 && yy-yd[1]>-3)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }
   
    public boolean selectobj(int xx,int yy)
    {
	setminmax();
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
    
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	setminmax();
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		setminmax();
		select = 1;
		return(true);
	    }
	return(false);
    }
}
