import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//********************************************************************

class Objetos_spline extends Objetos

//********************************************************************
{
    //    static final long serialVersionUID = 
    Color c;
    double alfa, alfa_old, xxc, yyc, longit=1, longit_old=1;
    int n;
    boolean cierra=false;
    Objetos_punto p1,p2,p3,p4;

    Objetos_spline(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    Objetos_spline(float xxg[],float yyg[],int np,Objetos_list p)
    {
	super(p);
	int i; 
        for (i=0;i<np;i++) {
	     xd[i] =(double)(xxg[i]/0.708) ;
	     yd[i] =(double)(yyg[i]/0.708) ;
	     if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
	     if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
	     if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
	     if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	     }
	int yccc=ymax+ymin;
        for (i=0;i<np;i++) yd[i]=(double)yccc-yd[i];
	n = np;
	ijk=1;
	select = 3;
    }

    Objetos_spline(double xxg[],double yyg[],int np,Objetos_list p)
    {
	super(p);
	int i; 
        for (i=0;i<np;i++) {
	     xd[i] =xxg[i] ;
	     yd[i] =yyg[i] ;
	     if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
	     if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
	     if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
	     if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	     }
	n = np;
	ijk=1;
	select = 3;
    }

    Objetos_spline(Objetos_punto o1, Objetos_punto o2, Objetos_punto o3, Objetos_punto o4, Objetos_list p)
    {
	super(p);
	p1=o1;p2=o2;p3=o3;p4=o4;
	ijk=1;
	select=3;
    }


  public void mueveobjeto(double xxg[], double yyg[])
  {
        for (int i=0;i<n;i++) {
	     xd[i] =xxg[i] ;
	     yd[i] =yyg[i] ;}
  }


    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D)g ;
	c=cc;
	int ik=0;
	g.setColor(new Color(230,230,230));
	if(select!=0)g2.drawString("   "+thickness,843,270);
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g.setColor(c);
	if(p1!=null)
	{
	    xd[0]=p1.xd[0];yd[0]=p1.yd[0];
	    xd[1]=p2.xd[0];yd[1]=p2.yd[0];
	    xd[2]=p3.xd[0];yd[2]=p3.yd[0];
	    xd[3]=p4.xd[0];yd[3]=p4.yd[0];
	    n=4;
	}

	Polygon p = new Polygon();
	for(int i=0;i<n;i++)
	    p.addPoint(xg[i],yg[i]);
	if(ijk==0)for(int i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	for(int i=0;i<n;i++){ xg[i]=(int)xd[i];yg[i]=(int)yd[i]; }
	setminmax();
	xxc=0;yyc=0;
	for(int ii=0; ii<n; ii++){xxc+=xd[ii];yyc+=yd[ii];}
	xc=xxc/n; yc=yyc/n;
	//	if(ijk==0){xd[n]=xc+40;yd[n]=yc;xd[n+1]=xc ;yd[n+1]=yc-40;}

float xA, yA, xB, yB, xC, yC, xD, yD, a0, a1, a2, a3, b0, b1, b2, b3, X=0, Y=0, xx0, xy0;
boolean first=true;
for(int i=1; i<n-2; i++) {
xA=(float)xd[0]; xB=(float)xd[1]; xC=(float)xd[2]; xD=(float)xd[3];
yA=(float)yd[0]; yB=(float)yd[1]; yC=(float)yd[2]; yD=(float)yd[3];
a3=(-xA+3*(xB-xC)+xD)/6;
b3=(-yA+3*(yB-yC)+yD)/6;
a2=(xA-2*xB+xC)/2; b2=(yA-2*yB+yC)/2;
a1=(xC-xA)/2;  b1=(yC-yA)/2;
a0=(xA+4*xB+xC)/6;  b0=(yA+4*yB+yC)/6; 
for(int j=0; j<=m; j++) {
xx0=X; yy0=Y;
float t=(float)j/(float)m;
X = ((a3*t+a2)*t+a1)*t+a0;
Y = ((b3*t+b2)*t+b1)*t+b0;
if(first){
GeneralPath spline = new GeneralPath();
spline.moveTo(xx0,yy0);
 first=false;
}
else spline.lineto((int)(X), (int)(Y));
} }
	forma[4] = (Shape) spline;
	GeneralPath lin = new GeneralPath();
	lin.moveTo((float)xc,(float)yc);
	lin.lineTo((float)xd[n],(float)yd[n]);
	GeneralPath lin2 = new GeneralPath();
	lin2.moveTo((float)xc,(float)yc);
	lin2.lineTo((float)xd[n+1],(float)yd[n+1]);
	Shape cont = (Shape)lin;
	Shape cont2 = (Shape)lin2;
	g2.setColor(cl) ;
	
	if(select!=0) 
	    {
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		for(int i = 0;i<n;i++)
		{
		    if(cierra==true){xg[n-1]=xg[0];yg[n-1]=yg[0];}
		    g.setColor(Color.red);
		    g2.drawLine(xg[i],yg[i],xg[(i+1)%n],yg[(i+1)%n]);
		    g.fillRect(xg[i]-1,yg[i]-1,3,3);
		    g2.draw(forma[4]);
		    if(i==0 || i==n-1)
		    {
		    }
		}
		if(n>3 && Drawing.ggll==1){
		    g2.setColor(Color.blue);
		    g2.draw(cont);
		    g2.draw(cont2);
		    g2.fillRect((int)xd[n]-1,(int)yd[n]-1,3,3);
		    g2.fillRect((int)xd[n+1]-1,(int)yd[n+1]-1,3,3);
		    g2.drawOval((int)xd[n]-3,(int)yd[n]-3,7,7);
		    g2.drawLine((int)xd[n+1]-4,(int)yd[n+1],(int)xd[n+1]+4,(int)yd[n+1]);
		    g2.drawLine((int)xd[n+1],(int)yd[n+1]-4,(int)xd[n+1],(int)yd[n+1]+4);
		    g2.fillRect((int)xc-1,(int)yc-1,3,3);
		    if(Math.abs(alfa) > 0.0001)Drawing.src32.setText("a1="+(float)((int)(alfa*1800/pi))/10);
		    if(Math.abs(longit) > 0.0001)Drawing.src33.setText("es="+(float)((int)(longit*100))/100);
		}
	    }

	    	if(select==0 && refill==1)
		    { 
			g2.setColor(cc); 
			g2.fill(forma[4]);
			g2.setColor(cl) ;
		    }
		if(select==0)
		    {
			stroke = new BasicStroke(thickness);
			if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
			g2.setStroke(stroke);
			g2.draw(forma[4]);
			g2.setColor(cl) ;
		    }
		
		if(putarr == true)
		    {
			g2.setColor(Color.blue);
			if((numarr/10)%10 == 1 && (numarr)%10 != 2) g.fillRect(xg[n-1]-1,yg[n-1]-1,3,3);
			if((numarr)%10 == 2) g.fillRect(xg[0]-2,yg[0]-1,5,5);
			if((numarr/10)%10 == 2) 
			    {
				g2.fillRect(xg[0]-2,yg[0]-2,5,5);
				g2.fillRect(xg[n-1]-2,yg[n-1]-2,5,5);
			    }
		    }
		g2.setColor(cl);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		
		rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
		if(g2.hit(rc,forma[4],true)) inters=true;
		else inters=false;
		
    }

public void metapost(BufferedWriter out) 
    {
	float ymd[] = new float[2*n];
	float xmd[] = new float[2*n];
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	if(c!=null)
	    {
		cr = (float)c.getRed()/255f;
		cv = (float)c.getGreen()/255f;
		ca = (float)c.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
        int m = n+(int)((n-4)/2.);
if(n==4)for(int i=0;i<n;i++){ ymd[i]=(float)(118*Drawing.u-yd[i]/(10*uesc));xmd[i]=(float)(xd[i]/(10*uesc)); }
else if(n>4)
    {
	xmd[0]=(float)(xd[0]/(10*uesc));ymd[0]=(float)(118*Drawing.u-yd[0]/(10*uesc));
	int j=0; int i=0;
	for(i=1; i<n-1; i++)
	    {
		j=j+1;
		if(i%2!=0 && i>2)
		    {
			xmd[j]=(float)((xd[i-1]+xd[i])/(2.*10*uesc));
			ymd[j]=(float)(118*Drawing.u)-(float)((yd[i-1]+yd[i])/(2.*10*uesc));
			j=j+1;
			xmd[j]=(float)(xd[i]/(10*uesc));
			ymd[j]=(float)(118*Drawing.u)-(float)(yd[i]/(10*uesc));
		    }
		else 
		    {
			xmd[j] = (float)(xd[i]/(10*uesc));
			ymd[j] = (float)(118*Drawing.u)-(float)(yd[i]/(10*uesc));
    }
			    }
      	xmd[j+1]=(float)(xd[i]/(10*uesc));
       	ymd[j+1]=(float)(118*Drawing.u)-(float)(yd[i]/(10*uesc));
    }
 

	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		if(putarr == true)
		    {
			if(miArrow0 != "")out.write(miArrow0);
			if(miArrow1 != "")out.write(miArrow1);
			if(miArrow2 != "")out.write(miArrow2);
			if(miArrow3 != "")out.write(miArrow3);
		    }
		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");

		if(n==4) out.write("("+xmd[0]+"u,"+ymd[0]+"u).. controls ("+xmd[1]+"u,"+ymd[1]+"u) and ("+xmd[2]+"u,"+ymd[2]+"u)..("+xmd[3]+"u,"+ymd[3]+"u)");


		else if(n>4)
		    {
				out.write("("+xmd[0]+"u,"+ymd[0]+"u).. controls ("+xmd[1]+"u,"+ymd[1]+"u) and ("+xmd[2]+"u,"+ymd[2]+"u)..("+xmd[3]+"u,"+ymd[3]+"u)");
				int l = m-2;
				if(m%2!=0) l=m-1;
				for(int i=4;i<l;i=i+3){
				    out.write(".. controls ("+xmd[i]+"u,"+ymd[i]+"u) and ("+xmd[i+1]+"u,"+ymd[i+1]+"u)..("+xmd[i+2]+"u,"+ymd[i+2]+"u)");}
			    } 
		    
		if(xmd[m-1]==xmd[0] && ymd[m-1]==ymd[0]){ out.write(" .. cycle"); flag=true; } else flag=false;
		if(refill==1 && flag!=true) out.write(";\npath b;\nb:=a -- ("+xmd[0]+"u,"+ymd[0]+"u) -- cycle;\n");
		else out.write(";\n");
		if(text_on_path==false)
		    {
			if(refill==1 && flag!=true) out.write( "fill b withcolor col;\n" );
			else if(refill==1)out.write("fill a withcolor col;\n");
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			    	     	out.write(drw+" a withcolor loc");
			else out.write(drw+" a");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }

		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }
  
    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	zmax = -100000;
	zmin = 100000;

	    for(int i=0;i<n+2;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)(xd[i]-5)  ;
		    if(yd[i]<(double)ymin) ymin = (int)(yd[i]-5)  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+5)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+5)  ;
		    if(zd[i]<(double)zmin) zmin = (int)(zd[i]-5)  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+5)  ;
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(ijk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ijk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ijk==0)
		    {
			xg[select-2] += xx;
			yg[select-2] += yy;
			if(select==n+2 || select==n+3)ijk=1;
		    }
		if(ijk==1)
		    {
			if(select!=n+3)xd[select-2] += (double)xx;
			yd[select-2] += (double)yy;
			if(select==n+2){girar();setminmax();}
			if(select==n+3){ampliar();setminmax();}
		    }
	    }
	if(select==1 && ijk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ijk==1)
	    for(int i=0;i<n;i++) {xd[i] += (double)xx; yd[i] += (double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
      if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	{
	  n--;
		return(true);
	}
      return(false);
    }

    public void girar() 
    {
	double xp, yp, s, c;
	alfa_old=alfa;
	xc=xxc/n;
	yc=yyc/n;;
	alfa=Math.atan2((yd[n]-yc),(xd[n]-xc));
	s=Math.sin(alfa-alfa_old); c=Math.cos(alfa-alfa_old);
	for(int i=0; i<n; i++){
	xp=(xd[i]-xc)*c-(yd[i]-yc)*s+xc;
	yp=(xd[i]-xc)*s+(yd[i]-yc)*c+yc;
	xd[i]=xp;yd[i]=yp;
	}
    }

    public void ampliar() 
    {
	double xp, yp;
	longit_old=longit;
	xc=xxc/n;
	yc=yyc/n;
	if(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc))<5)return;
	longit=(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc)))/(40*Drawing.u);
	for(int i=0; i<n; i++){
	xd[i]=(xd[i]-xc)*(longit/longit_old)+xc;
	yd[i]=(yd[i]-yc)*(longit/longit_old)+yc;
	}
    }


public void bsplin(Graphics g) {
int m=50;
float xA, yA, xB, yB, xC, yC, xD, yD, a0, a1, a2, a3, b0, b1, b2, b3, x=0, y=0, x0, y0;
boolean first=true;
for(int i=1; i<n-2; i++) {
xA=P[i-1].x; xB=P[i].x; xC=P[i+1].x; xD=P[i+2].x;
yA=P[i-1].y; yB=P[i].y; yC=P[i+1].y; yD=P[i+2].y;
a3=(-xA+3*(xB-xC)+xD)/6;
b3=(-yA+3*(yB-yC)+yD)/6;
a2=(xA-2*xB+xC)/2; b2=(yA-2*yB+yC)/2;
a1=(xC-xA)/2;  b1=(yC-yA)/2;
a0=(xA+4*xB+xC)/6;  b0=(yA+4*yB+yC)/6; 
for(int j=0; j<=m; j++) {
x0=x; y0=y;
float t=(float)j/(float)m;
x = ((a3*t+a2)*t+a1)*t+a0;
y = ((b3*t+b2)*t+b1)*t+b0;
if(first) first=false;
else g.drawLine(iX(x0), iY(y0), iX(x), iY(y));
} }
}
}

class Point2D
{  float x, y;
   Point2D(float x, float y){this.x = x; this.y = y;}
}

