import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;


//***********************************************************************

class Objetos_linea extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 8933116696395576718L;
    Color c;
    int x0,y0,x1,y1,esy=1180,n=2,ikk=0,nn=0,num=0;
    double m=0,m1=0,mp1=0,mp=0,h0,h1,r,h01,h11,teta1=0;
    static double d0,d1,d2,tt;
    Objetos_mpcircle miCir;
    Objetos_oval miOval;
    Objetos_punto miPunto, miPunto2;
    Objetos_linea miLinea, miLinea2;
    int  tipo=Drawing.lil;
    int  tipo_old=Drawing.lil_last;


/*CONSTRUCTORES*/

/*Construye una recta dibujndola: num=0 */
Objetos_linea(int x, int y, Objetos_list p)
{
    super(p);
    x0 = x1 = xmin = xmax = x;
    y0 = y1 = ymin = ymax = y;
    xd[0]=(double)x0; xd[1]=(double)x1;
    yd[0]=(double)y0; yd[1]=(double)y1;
    nombre="li";
    select = 3;
}
/*Construye una recta leyendo las coordenadas exactas: num=0 */
Objetos_linea(double x0, double y0, double x1, double y1, Objetos_list p)
{
    super(p);
    xd[0]=x0; xd[1]=x1; yd[0]=y0; yd[1]=y1;
    nombre="li";
    select = 3;
}

/*Construye una recta que une dos puntos dados: num=1 */
Objetos_linea(Objetos_punto p1, Objetos_punto p2, int h, Objetos_list p)
{
    super(p);
    num=h;
    miPunto = p1;
    miPunto2 = p2;
    nombre="li";
    init1();
    select=3;
}


/* Construye una recta perpendicular a otra desde un punto dado o
una recta paralela a otra desde un punto dado o
que une el punto medio de un segmento con un punto dado: 
num=2, 3 o 4. */
Objetos_linea(Objetos_punto p1, Objetos_linea l1, int h, Objetos_list p)
{
    super(p);
    num=h;
    miPunto = p1;
    miLinea = l1;
    nombre="li";
    select=3;
}

/* Construye una recta mediatriz de un segmento dado: num=5 */
Objetos_linea(Objetos_linea l1, int h, Objetos_list p)
{
    super(p);
    miLinea=l1;
    num=h;
    nombre="li";
    select=3;
}

/* Construye una recta mediatriz de un segmento dado: num=5 */
Objetos_linea(Objetos_linea l1, int h)
{
//    super(p);
    miLinea=l1;
    num=h;
    nombre="li";
    select=3;
}

/* Construye la bisectriz del ngulo formado por dos segmentos en
el lado donde colocamos dos puntos: num=6 */ 
Objetos_linea(Objetos_linea l1, Objetos_linea l2, Objetos_punto p1, Objetos_punto p2, int h, Objetos_list p)
{
    super(p);
    miPunto = p1;
    miPunto2 = p2;
    miLinea = l1;
    miLinea2 = l2;
    num = h;
    nombre="li";
    select=3;
}

/* Construye la recta tangente a un crculo: num=7 */
Objetos_linea(Objetos_punto p1, Objetos_mpcircle cir, int h, int i, Objetos_list p)
{
    super(p);
    miPunto = p1;
    miCir = cir;
    num=h;
    nn=i;
    nombre="li";
    select=3;
}

/* Construye la recta tangente a una elipse: num=8 */
Objetos_linea(Objetos_punto p1, Objetos_oval o1, int h, int i, Objetos_list p)
{
    super(p);
    miPunto = p1;
    miOval = o1;
    num = h;
    nn=i;
    nombre="li";
    select=3;
}

/* Constructor para crear los ejes de una elipse. */
    Objetos_linea(Objetos_oval o1, int ii, Objetos_list p)
	{
	    super(p);
	    nombre="li";
	    num=9;
	    nn=ii;
	    miOval = o1; 
	    select=3;
	}


public void transform(double xc, double yc, double zc)
{
    ikk=1;
    modi(xc,yc,zc,2);
    /* x0=(int)xd[0];
    x1=(int)xd[1];
    y0=(int)yd[0];
    y1=(int)yd[1];*/
}

public void paint(Graphics g) 
{
    c = cc;
    Graphics2D g2 = (Graphics2D) g ;
    CSD = false;

    if(num==1) //Recta que pasa por dos puntos
    {
	xd[0]=miPunto.xd[0]; yd[0]=miPunto.yd[0];
	xd[1]=miPunto2.xd[0]; yd[1]=miPunto2.yd[0];
    }

    if(num==2) //Recta perpendicular a otra por un punto
    {
	xd[5]=miPunto.xd[0]; yd[5]=miPunto.yd[0];
	xd[1]=miLinea.yd[0]; xd[2]=miLinea.yd[1];
	yd[1]=miLinea.xd[1]; yd[2]=miLinea.xd[0];
	d1 = xd[5]-xd[1]; d2=yd[5]-yd[1];
	xd[1]+=d1;xd[2]+=d1;yd[1]+=d2;yd[2]+=d2;
	xd[3]=miLinea.xd[0]; xd[4]=miLinea.xd[1];
	yd[3]=miLinea.yd[0]; yd[4]=miLinea.yd[1];
	Objetos_punto.intersec(xd,yd);
    }

    if(num==3) //Recta paralela a otra por un punto
    {
	xd[0]=miPunto.xd[0]; yd[0]=miPunto.yd[0];
	xd[2]=miLinea.xd[0];yd[2]=miLinea.yd[0];
	xd[3]=miLinea.xd[1];yd[3]=miLinea.yd[1];
	xd[4]=(xd[2]+xd[3])/2.; yd[4]=(yd[2]+yd[3])/2.;
	xd[0]-=xd[4]-xd[2]; yd[0]-=yd[4]-yd[2];
	xd[1]=xd[0]+xd[3]-xd[2];
	yd[1]=yd[0]+yd[3]-yd[2];
    }

    if(num==4) //Recta que une el punto medio de otra con un punto
    {
	xd[0]=miPunto.xd[0]; yd[0]=miPunto.yd[0];
	xd[2]=miLinea.xd[0];yd[2]=miLinea.yd[0];
	xd[3]=miLinea.xd[1];yd[3]=miLinea.yd[1];
	xd[1]=(xd[2]+xd[3])/2.;
	yd[1]=(yd[2]+yd[3])/2.;
    }

    if(num==5) //Recta mediatriz de un segmento
    {
	xd[11]=miLinea.xd[0];xd[12]=miLinea.xd[1];
	yd[11]=miLinea.yd[0];yd[12]=miLinea.yd[1];
	mediatrz(xd, yd);
    }

    if(num==6) //Recta bisectriz de otras dos	
    {
	xd[1]=miLinea.xd[0];xd[2]=miLinea.xd[1];
	xd[3]=miLinea2.xd[0];xd[4]=miLinea2.xd[1];
	yd[1]=miLinea.yd[0];yd[2]=miLinea.yd[1];
	yd[3]=miLinea2.yd[0];yd[4]=miLinea2.yd[1];
	intersec(xd,yd);
	xd[1]=miPunto.xd[0];yd[1]=miPunto.yd[0];
	xd[2]=miPunto2.xd[0];yd[2]=miPunto2.yd[0];
	d1 = Math.sqrt((xd[0]-xd[1])*(xd[0]-xd[1])+(yd[0]-yd[1])*(yd[0]-yd[1]));
	d2 = Math.sqrt((xd[0]-xd[2])*(xd[0]-xd[2])+(yd[0]-yd[2])*(yd[0]-yd[2]));
	xd[3]=(d1*(xd[2]-xd[0])+d2*(xd[1]-xd[0]))/(d1+d2);
	yd[3]=(d1*(yd[2]-yd[0])+d2*(yd[1]-yd[0]))/(d1+d2);
	xd[1]=xd[0]+xd[3]; yd[1]=yd[0]+yd[3];
    }

    if(num==7) //Recta tangente a un circulo
    {
	xd[0]=miPunto.xd[0]; yd[0]=miPunto.yd[0];
	xd[2]=miCir.xd[0];yd[2]=miCir.yd[0];
	r=miCir.R1;
	double beta = Math.atan((yd[2]-yd[0])/(xd[2]-xd[0]));
	double dist = Math.sqrt((xd[2]-xd[0])*(xd[2]-xd[0])+(yd[2]-yd[0])*(yd[2]-yd[0]));
	double alfa = Math.asin(r/dist);
	if(nn==2)teta1 = beta+alfa;
	if(nn==1)teta1 = beta-alfa;
	double mp = Math.tan(teta1);
	if(mp==0)mp=0.000001;
	m = -1/mp;
	h0 = yd[2]-m*xd[2];
	h1=yd[0]-mp*xd[0];
	xd[1]=(h0-h1)/(mp-m); yd[1]=m*xd[1]+h0;
    }

    if(num==8) //Recta tangente a una elipse
    {
	double xdd[] = new double[4];double ydd[] = new double[4];
	double alfa=0, xp, yp, c, s, xcentro, ycentro;
	xdd[0]=miOval.xd[0];xdd[1]=miOval.xd[1];
	xdd[2]=miOval.xd[2];xdd[3]=miOval.xd[3];
	ydd[0]=miOval.yd[0];ydd[1]=miOval.yd[1];
	ydd[2]=miOval.yd[2];ydd[3]=miOval.yd[3];
	xcentro=(xdd[0]+xdd[1]+xdd[2]+xdd[3])/4; 
	ycentro=(ydd[0]+ydd[1]+ydd[2]+ydd[3])/4;
	alfa=Math.atan((ydd[3]-ydd[0])/(xdd[3]-xdd[0]));
	s=Math.sin(alfa); c=Math.cos(alfa);
	for(int i=0; i<2; i++){
	xp=(xdd[i]-xcentro)*c+(ydd[i]-ycentro)*s+xcentro;
	yp=-(xdd[i]-xcentro)*s+(ydd[i]-ycentro)*c+ycentro;
	xdd[i]=xp;ydd[i]=yp;
	}
	xd[0] = miPunto.xd[0]; yd[0] = miPunto.yd[0];
	xp=(xd[0]-xcentro)*c+(yd[0]-ycentro)*s+xcentro;
	yp=-(xd[0]-xcentro)*s+(yd[0]-ycentro)*c+ycentro;
	xd[0]=xp;yd[0]=yp;
	double a = (xdd[1]-xdd[0])/2.;
	double b = (ydd[1]-ydd[0])/2.;
	double aa = b*b*(xd[0]-xcentro);
	double bb = a*a*(yd[0]-ycentro);
	double cc = -b*b*xcentro*(xd[0]-xcentro)-a*a*ycentro*(yd[0]-ycentro)-a*a*b*b;
	double d = -aa/bb; 
	double f=-cc/bb-ycentro;
	double e = b*b+a*a*d*d;
	double u = (2*a*a*d*f-2*b*b*xcentro)/e;
	double v = (b*b*xcentro*xcentro+a*a*f*f-a*a*b*b)/e;
	double w = Math.sqrt(u*u-4.*v);
	if(nn==1)xd[1]=(-u+w)/2.;
	if(nn==2)xd[1]=(-u-w)/2.; 
	yd[1]=d*xd[1]-cc/bb;
	xp=(xd[1]-xcentro)*c-(yd[1]-ycentro)*s+xcentro;
	yp=(xd[1]-xcentro)*s+(yd[1]-ycentro)*c+ycentro;
	xd[1]=xp;yd[1]=yp;
	xp=(xd[0]-xcentro)*c-(yd[0]-ycentro)*s+xcentro;
	yp=(xd[0]-xcentro)*s+(yd[0]-ycentro)*c+ycentro;
	xd[0]=xp;yd[0]=yp;
    }

    if(num==9) //Ejes de una elipse
    {
	if(nn==1)
	{
	    xd[0]=(double)miOval.xn0;yd[0]=(double)miOval.yn0;
	    xd[1]=(double)miOval.x6;yd[1]=(double)miOval.y6;
	}
	else if(nn==2)
	{
	    xd[0]=(double)miOval.x3;yd[0]=(double)miOval.y3;
	    xd[1]=(double)miOval.x9;yd[1]=(double)miOval.y9;
	}
    }

    float strokeThickness = thickness;
    BasicStroke stroke = new BasicStroke(strokeThickness);
    g2.setStroke(stroke);
    setminmax();
    xc = (xd[0]+xd[1])/2;
    yc = (yd[0]+yd[1])/2;
    zc = (zd[0]+zd[1])/2;
    int x = (int)xd[0];
    int y = (int)yd[0];
    if(x>(int)xd[1]) x = (int)xd[1];
    if(y>(int)yd[1]) y = (int)yd[1];
	GeneralPath lline = new GeneralPath();
	lline.moveTo((float)xd[0],(float)yd[0]);
	lline.lineTo((float)xd[1],(float)yd[1]);
	Shape miLINEA = (Shape)lline;
    if(select!=0)
    {
	g2.setColor(Color.red);
	g2.draw(miLINEA);
	g2.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
	g2.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
    }
    else
    {
	g2.setColor(cl);
	stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
	g2.setStroke(stroke);
	g2.draw(miLINEA);
	if(putarr == true)
	{
	    g2.setColor(Color.blue);
	    if((numarr/10)%10 == 1 && numarr%10 != 2) g2.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    if(numarr%10 == 2) g2.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
	    if((numarr/10)%10 == 2) 
	    {
		g2.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
		g2.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    }
	}
	g2.setColor(cl);
    }

    rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
    if(g2.hit(rc,miLINEA,true))inters=true;
    else inters=false;
    stroke = new BasicStroke(0.5f);
    g2.setStroke(stroke);
    g2.setColor(cl);
    if(tipo!=tipo_old)Drawing.lil_last=tipo;
}

public void metapost(BufferedWriter out) 
{
	if(tipo!=tipo_old){
	if(tipo%3==1)drw="linecap:= rounded;\ndraw";
	else if(tipo%3==2)drw="linecap:= butt;\ndraw";
	else if(tipo%3==0)drw="linecap:= squared;\ndraw";
	}
    try 
    {
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	float esy0 = (float)(118*Drawing.u)-(float)(yd[0]/(10*uesc));
	float esy1 = (float)(118*Drawing.u)-(float)(yd[1]/(10*uesc));

	if(putarr == true)
	{
	    if(miArrow0 != "")out.write(miArrow0);
	    if(miArrow1 != "")out.write(miArrow1);
	    if(miArrow2 != "")out.write(miArrow2);
	    if(miArrow3 != "")out.write(miArrow3);
	}
	out.write("pickup pencircle scaled "+thickness+";\npath a;\n");
	out.write ("loc:=("+rc+","+vc+","+ac+");\n");
	out.write("a:= ("+(float)(xd[0]/(10*uesc))+"u,"+(float)esy0+"u)--("+(float)(xd[1]/(10*uesc))+"u,"+esy1+"u);\n") ;
	out.write(drw+" a withcolor loc "); 
	if(linea!=0)out.write(tipo_linea);
	else out.write(";\n");
    }
    catch (IOException ex) { }
}

public void setminmax()
{
    xmin = 100000;
    ymin = 100000;
    xmax = -100000;
    ymax = -100000;
    zmax = -100000;
    zmin = 100000;
    for(int i=0;i<2;i++)

    {
	if(xd[i]<(double)xmin) xmin = (int)xd[i]-2  ;
	if(yd[i]<(double)ymin) ymin = (int)yd[i]-2  ;
	if(xd[i]>(double)xmax) xmax = (int)(xd[i]+2)  ;
	if(yd[i]>(double)ymax) ymax = (int)(yd[i]+2)  ;
	if(zd[i]<(double)zmin) zmin = (int)zd[i]-2  ;
	if(zd[i]>(double)zmax) zmax = (int)(zd[i]+2)  ;
    }
}

public void moveobj(int xx,int yy)
{
    x0 += xx; xd[0] += (double)xx;
    y0 += yy; yd[0] += (double)yy;
    x1 += xx; xd[1] += (double)xx;
    y1 += yy; yd[1] += (double)yy;
    setminmax();
}
public void movepoint(int x,int y)
{
    if(select==3){ x1 += x;y1 += y; xd[1] += (double)x; yd[1] += (double)y;}
    if(select==2){ x0 += x;y0 += y; xd[0] += (double)x; yd[0] += (double)y;}
    setminmax();
}

public boolean selectpoint(int xx,int yy)
{
    if(xx-(int)xd[0]<5*Drawing.u && xx-(int)xd[0]>-5*Drawing.u && yy-(int)yd[0]<5*Drawing.u && yy-yd[0]>-5*Drawing.u)
    {
	select = 2;
	return(true);
    }
    if(xx-(int)xd[1]<5*Drawing.u && xx-(int)xd[1]>-5*Drawing.u && yy-(int)yd[1]<5*Drawing.u && yy-yd[1]>-5*Drawing.u)
    {
	select = 3;
	return(true);
    }
    return(false);
}

public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
{
    setminmax();
    if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
    {
	setminmax();
	select = 1;
	return(true);
    }
    return(false);
}

public static void mediatrz (double xd[], double yd[])
{
	xd[2]=(xd[11]+xd[12])/2.;
	yd[2]=(yd[11]+yd[12])/2.;
	xd[0]=yd[11]; xd[1]=yd[12];
	yd[0]=xd[12]; yd[1]=xd[11];
	xd[3]=(xd[0]+xd[1])/2.; yd[3]=(yd[0]+yd[1])/2.;
	xd[4]=xd[2]-xd[3]; yd[4]=yd[2]-yd[3];
	xd[0]+=xd[4]; xd[1]+=xd[4];
	yd[0]+=yd[4]; yd[1]+=yd[4];
}

public static void intersec(double[] xd, double[] yd)
{
    tt=(yd[4]-yd[3])*(xd[3]-xd[1])-(yd[3]-yd[1])*(xd[4]-xd[3]);
    tt/=((yd[4]-yd[3])*(xd[2]-xd[1])-(yd[2]-yd[1])*(xd[4]-xd[3]));
    xd[0]=xd[1]+(xd[2]-xd[1])*tt;
    yd[0]=yd[1]+(yd[2]-yd[1])*tt;
}

public void init1()
{
	xd[0]=miPunto.xd[0]; yd[0]=miPunto.yd[0];
	xd[1]=miPunto2.xd[0]; yd[1]=miPunto2.yd[0];
}




}
