import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//********************************************************************

class Objetos_qbrd extends Objetos

//********************************************************************
{
    static final long serialVersionUID = 6083861719285491133L;
    int n;
    Color c;
    Objetos_punto mypt=null;
    Objetos_list milist;
    double alfa, alfa_old, xxc, yyc, longit=1, longit_old=1;
    int tipo=Drawing.lil;
    int tipo_old=Drawing.lil_last;
    int junta=Drawing.join;
    int junta_old=Drawing.join_last;
    float thickness_old=0.5f;
    String nombre="qbr";

    Objetos_qbrd(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	tipo=Drawing.lil;
	tipo_old=Drawing.lil_last;
	select = 3;
    }

    Objetos_qbrd(float xxg[],float yyg[],int np,Color cc,Objetos_list p)
    {
	super(p);
	milist=p;
	int i ;
        for (i=0;i<np;i++) 
	    {
		xd[i] =(double)(xxg[i]/0.708) ;
		yd[i] =(double)(yyg[i]/0.708) ;
		if (xmin > xd[i]) xmin  = (int)(xd[i]-5) ;
		if (xmax < xd[i]) xmax  = (int)(xd[i]+5) ;
		if (ymin > yd[i]) ymin  = (int)(yd[i]-5) ;
		if (ymax < yd[i]) ymax  = (int)(yd[i]+5) ;
	    }
	int yccc=1180;
        for (i=0;i<np;i++)yd[i]=yccc-yd[i];
	n = np;
	ijk=1;
	select = 1;
    }

    Objetos_qbrd(double xxg[],double yyg[],int np,Objetos_list p)
    {
	super(p);
	int i ;
        for (i=0;i<np;i++) 
	    {
		xd[i] = xxg[i] ;
		yd[i] = yyg[i] ;
		xg[i] = (int)(xd[i]+0.5);
		yg[i] = (int)(yd[i]+0.5);
		if (xmin > xd[i]) xmin  = (int)(xd[i]-5) ;
		if (xmax < xd[i]) xmax  = (int)(xd[i]+5) ;
		if (ymin > yd[i]) ymin  = (int)(yd[i]-5) ;
		if (ymax < yd[i]) ymax  = (int)(yd[i]+5) ;
	    }
	n = np;
	ijk=1;
    }

    Objetos_qbrd(double xxg[],double yyg[],int np, String aaa, Objetos_list p)
    {
	super(p);
	int i ;
	String ayu;
        for (i=0;i<np-1;i++) 
	    {
		xd[i] = xxg[i] ;
		yd[i] = yyg[i] ;
		xg[i] = (int)(xd[i]+0.5);
		yg[i] = (int)(yd[i]+0.5);
		if (xmin > xd[i]) xmin  = (int)(xd[i]-5) ;
		if (xmax < xd[i]) xmax  = (int)(xd[i]+5) ;
		if (ymin > yd[i]) ymin  = (int)(yd[i]-5) ;
		if (ymax < yd[i]) ymax  = (int)(yd[i]+5) ;
	    }
	yd[np-1] = yd[0]; xd[np-1]=xd[0];
	yg[np-1] = yg[0]; xg[np-1]=xg[0];
	ayu=aaa;
	n = np;
	ijk=1;
    }

    Objetos_qbrd(Objetos_punto p1, Color cc, Objetos_list p)
    {
	super(p);
	mypt=p1;
	cl=cc;
	xg[0] = xg[1] = xmin = xmax = (int)mypt.xd[0];
	yg[0] = yg[1] = ymin = ymax = (int)mypt.yd[0];
	n = 2;
	nombre="qbrd_draw";
	Drawing.ggll=1;
    }


    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0,i;
	Graphics2D g2 = (Graphics2D) g ;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	Polygon p = new Polygon();
	if(ijk==0){
	for(i=0;i<n;i++)if(this.nombre!="qbrd_draw")
	    p.addPoint(xg[i],yg[i]);
	if(mypt!=null && this.nombre=="qbrd_draw"){
	    if((Math.abs(xg[n]-(int)mypt.xd[0])>4 || Math.abs(yg[n]-(int)mypt.yd[0])>4) && (mypt.xd[0]>1 && mypt.yd[0]>1 && mypt.select==1 && Drawing.ggll==1))
		addpoint((int)mypt.xd[0],(int)mypt.yd[0]);
	}       	
	for(i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	}
	else for(i=0;i<n;i++){xg[i]=(int)xd[i];yg[i]=(int)yd[i]; }
	setminmax();
	xxc=0;yyc=0;
	for(int ii=0; ii<n; ii++){xxc+=xd[ii];yyc+=yd[ii];}
	xc=xxc/n; yc=yyc/n;
	if(ijk==0){xd[n]=xc+40;yd[n]=yc;xd[n+1]=xc ;yd[n+1]=yc-40  ;}
	GeneralPath quebrada = new GeneralPath();
	quebrada.moveTo((float)xd[0],(float)yd[0]);
	for(i = 1;i<n;i++)
	    quebrada.lineTo((float)xd[i],(float)yd[i]);
	Shape miQbrd = (Shape)quebrada;
	GeneralPath lin = new GeneralPath();
	lin.moveTo((float)xc,(float)yc);
	lin.lineTo((float)xd[n],(float)yd[n]);
	GeneralPath lin2 = new GeneralPath();
	lin2.moveTo((float)xc,(float)yc);
	lin2.lineTo((float)xd[n+1],(float)yd[n+1]);
	Shape cont = (Shape)lin;
	Shape cont2 = (Shape)lin2;

	if(select!=0)
	    {
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		g2.setColor(Color.red) ;
		g2.draw(miQbrd);
		for(i = 0;i<n;i++) g2.fillRect((int)xd[i]-1,(int)yd[i]-1,3,3);
		if(n>2 && Drawing.ggll==1){
		g2.setColor(Color.blue);
		g2.draw(cont);
		g2.draw(cont2);
		g2.fillRect((int)xd[n]-1,(int)yd[n]-1,3,3);
		g2.fillRect((int)xd[n+1]-1,(int)yd[n+1]-1,3,3);
		g2.drawOval((int)xd[n]-3,(int)yd[n]-3,7,7);
		g2.drawLine((int)xd[n+1]-4,(int)yd[n+1],(int)xd[n+1]+4,(int)yd[n+1]);
		g2.drawLine((int)xd[n+1],(int)yd[n+1]-4,(int)xd[n+1],(int)yd[n+1]+4);
		g2.fillRect((int)xc-1,(int)yc-1,3,3);
		if(Math.abs(alfa) > 0.0001)Drawing.src32.setText("a1="+(float)((int)(alfa*1800/pi))/10);
		if(Math.abs(longit) != 1)Drawing.src33.setText("es="+(float)((int)(longit*100))/100);

		}
	    }
	if(select==0 && refill==1)
	    { 
		g2.setColor(cc); 
		g2.fill(miQbrd);
		stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		g2.draw(miQbrd);
	    }

	else if(select==0)
	    {
		g2.setColor(cl); 
		stroke = new BasicStroke(thickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
		g2.setStroke(stroke);
		g2.draw(miQbrd);
	    }

	if(putarr == true)
	    {
		g2.setColor(Color.blue);
		if((numarr/10)%10 == 1 && (numarr)%10 != 2) g.fillRect(xg[n-1]-1,yg[n-1]-1,3,3);
		if((numarr)%10 == 2) g.fillRect(xg[0]-1,yg[0]-1,3,3);
		if((numarr/10)%10 == 2) 
		    {
			g2.fillRect(xg[0]-1,yg[0]-1,3,3);
			g2.fillRect(xg[n-1]-1,yg[n-1]-1,3,3);
		    }
	    }


	rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
        if(g2.hit(rc,miQbrd,true)) inters=true;
	else inters=false;

	g2.setColor(cl);
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	if(tipo!=tipo_old)Drawing.lil_last=tipo;
	if(junta!=junta_old)Drawing.join_last=junta;
    }

    public void metapost(BufferedWriter out) 
    {
	if(this.nombre=="qbrd_draw")n--;
	if(tipo!=tipo_old){
		if(tipo%3==1)drw="linecap:= rounded;\ndraw";
		else if(tipo%3==2)drw="linecap:= butt;\ndraw";
		else if(tipo%3==0)drw="linecap:= squared;\ndraw";
	}
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	float xmd[] = new float[n]; float ymd[] = new float[n];
	if(c!=null)
	    {
		cr = (float)c.getRed()/255f;
		cv = (float)c.getGreen()/255f;
		ca = (float)c.getBlue()/255f;
	    }

	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
	for(int i=0;i<n;i++){ ymd[i]=(float)(118*Drawing.u)-(float)(yd[i]/(10*uesc));xmd[i]=(float)xd[i]/(10*uesc); }
	if(Math.abs(xmd[n-1]-xmd[0]) <=2 && Math.abs(ymd[n-1]-ymd[0]) <=2){xmd[n-1]=xmd[0]; ymd[n-1]=ymd[0];}
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		if(putarr == true)
		    {
			if(miArrow0 != "")out.write(miArrow0);
			if(miArrow1 != "")out.write(miArrow1);
			if(miArrow2 != "")out.write(miArrow2);
			if(miArrow3 != "")out.write(miArrow3);
		    }
		if(thickness != thickness_old){
		out.write("pickup pencircle scaled "+thickness+";");
		}
		out.write("\npath a;\na:=");
		out.write("("+xmd[0]+"u,"+ymd[0]+"u) -- ("+xmd[1]+"u,"+ymd[1]+"u)");
		for(int i=2;i<n;i++) out.write(" -- ("+xmd[i]+"u,"+ymd[i]+"u)");
		if(xmd[n-1]==xmd[0] && ymd[n-1]==ymd[0]){out.write("--cycle;\n");flag=true;}
		else out.write(";\n");
		if(junta != junta_old){
		    if(junta%3==1 && junta!=1)out.write("linejoin:=rounded;\n");
		    if(junta%3==2)out.write("linejoin:=mitered;\n");
		    if(junta%3==0)out.write("linejoin:=beveled;\n");
		}
		if(refill==1 && flag!=true)out.write("path b;\nb:= a -- cycle;\n");

		if(text_on_path==false)
		    {
			if(refill==1 && flag!=true) out.write( "fill b withcolor col;\n" );
			else if(refill==1) out.write("fill a withcolor col;\n");
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		        out.write(drw+" a withcolor loc ");
			else out.write(drw+" a ");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }

		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }

    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	zmax = -100000;
	zmin = 100000;
	
	if(ijk==1)
	    for(int i=0;i<n+2;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)xd[i]-5  ;
		    if(yd[i]<(double)ymin) ymin = (int)yd[i]-5  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+5)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+5)  ;
		    if(zd[i]<(double)zmin) zmin = (int)zd[i]-5  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+5)  ;
		}
	
	if(ijk==0)
	    for(int i=0;i<n;i++)
		{
		    if(xg[i]<xmin) xmin = xg[i]-5;
		    if(yg[i]<ymin) ymin = yg[i]-5;
		    if(xg[i]>xmax) xmax = xg[i]+5;
		    if(yg[i]>ymax) ymax = yg[i]+5;
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(ijk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ijk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ijk==0)
		    {
		xg[select-2] += xx;
		yg[select-2] += yy;
		if(select==n+2 || select==n+3)ijk=1;
		    }
		if(ijk==1)
		    {
		if(select!=n+3)xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
		if(select==n+2){girar();setminmax();}
		if(select==n+3){ampliar();setminmax();}
		    }
	    }
	if(select==1 && ijk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ijk==1)
	    for(int i=0;i<n;i++) {xd[i]+=(double)xx; yd[i]+=(double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }
 
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	boolean a,b,c;
	double d;
	if(ijk==0){
	    xg[n] = xx; xd[n] = (double)xx;
	    yg[n] = yy; yd[n] = (double)yy;
	}
	else if(ijk==1){
	    xd[n] = (double)xx; xg[n] = xx;
	    yd[n] = (double)yy; yg[n] = yy;
	}
	d=Math.sqrt((xd[n-1]-xd[n-2])*(xd[n-1]-xd[n-2])+(yd[n-1]-yd[n-2])*(yd[n-1]-yd[n-2]));
	a=(n>3 && Drawing.ggll==1 && this.nombre=="qbrd_draw");
	b=(Math.abs(xd[n-1]-xd[n-2])<0.001 && Math.abs(xd[n]-xd[n-1])<0.001);
        c=Math.abs(((yd[n-1]-yd[n-2])/(xd[n-1]-xd[n-2]))-((yd[n]-yd[n-1])/(xd[n]-xd[n-1])))*d < 2;
	if((a && b) || (a && c)){
	    xg[n-1]=xg[n]; yg[n-1]=yg[n]; xd[n-1]=xd[n]; yd[n-1]=yd[n]; n--;
	}
	Drawing.src32.setText("num="+n);
	    select = n+2;
	    n++;
	    setminmax();
    }


    public boolean done()
    {
      if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	{
	  n--;
		return(true);
	}
      return(false);
    }

    public void girar() 
    {
	double xp, yp, s, c;
	alfa_old=alfa;
	xc=xxc/n;
	yc=yyc/n;;
	alfa=Math.atan2((yd[n]-yc),(xd[n]-xc));
	s=Math.sin(alfa-alfa_old); c=Math.cos(alfa-alfa_old);
	for(int i=0; i<n; i++){
	xp=(xd[i]-xc)*c-(yd[i]-yc)*s+xc;
	yp=(xd[i]-xc)*s+(yd[i]-yc)*c+yc;
	xd[i]=xp;yd[i]=yp;
	}
    }

    public void ampliar() 
    {
	double xp, yp;
	longit_old=longit;
	xc=xxc/n;
	yc=yyc/n;
	if(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc))<5)return;
	longit=(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc)))/(40*Drawing.u);
	for(int i=0; i<n; i++){
	xd[i]=(xd[i]-xc)*(longit/longit_old)+xc;
	yd[i]=(yd[i]-yc)*(longit/longit_old)+yc;
	}
    }

}
