import java.awt.*;
import java.awt.event.*;
import javax.swing.* ;
import javax.swing.border.*;
import java.io.*;

public class Tools extends JPanel 
{
    static final long serialVersionUID = -1866484324645885070L;
  int n;
  JButton set;
  int status = 0, oldstatus = 0;    
  Color back  = new Color(210,210,210);
  Color dgray = new Color(60,60,60);
  Color cstat = new Color(0,0,0);
  JButton lin;
  Conexiona ayu = new Conexiona();
  Drawing parent;
    Tools()
    {
	setBackground(back);

	Icon angl = new ImageIcon("images/arco.png");
	Icon ghost = new ImageIcon("images/gv.png");
	Icon rectan = new ImageIcon("images/rectangulo.png");
	Icon texto = new ImageIcon("images/texto.png");
	Icon spline = new ImageIcon("images/bezier.png");
	Icon elipse = new ImageIcon("images/ovalo.png");
	Icon polyg = new ImageIcon("images/poligono.png");
	Icon salida = new ImageIcon("images/newexit.png");
	Icon flecha = new ImageIcon("images/flecha.png");
        Icon doble = new ImageIcon("images/flechas.png");
	Icon punto = new ImageIcon("images/circulo.png");
	Icon color = new ImageIcon("images/color.png");
	Icon open = new ImageIcon("images/newopen.png");
	Icon savep = new ImageIcon("images/newsave.png");
	Icon fill = new ImageIcon("images/llena.png");
	Icon mass = new ImageIcon("images/espiral.png");
	Icon menoss = new ImageIcon("images/point.png");
	Icon borrar = new ImageIcon("images/limpia.png");
	Icon elim = new ImageIcon("images/borra.png");
	Icon agrupa = new ImageIcon("images/agrupa.png");
	Icon desag = new ImageIcon("images/desagrupa.png");
	Icon killp = new ImageIcon("images/newkill.png");
	Icon coobj = new ImageIcon("images/copia.png");
	Icon malla = new ImageIcon("images/malla.png");
	Icon copy = new ImageIcon("images/newcopy.png");
	Icon past = new ImageIcon("images/newpaste.png");
	Icon circle = new ImageIcon("images/bezicirc.png");
	Icon trans = new ImageIcon("images/transf.png");
	Icon rota = new ImageIcon("images/select.png");
	Icon tEx = new ImageIcon("images/eje.png");
	Icon especial = new ImageIcon("images/sp.png");
	Icon lInea = new ImageIcon("images/puntos.png");
	Icon rset = new ImageIcon("images/reset.png");
	Icon metac = new ImageIcon("images/line.png");
	Icon linea = new ImageIcon("images/recta.png");
	Icon splin = new ImageIcon("images/splin.png");

	JButton spli = new JButton() ;
	spli = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
 	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	spli.setIcon(splin);
	spli.setSize(30,30);
	spli.setToolTipText("Genera un beta_spline con el número de puntos de control deseado");
	spli.setBackground(back);
	spli.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 18 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );

	JButton abrir = new JButton() ;
	abrir = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
 	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	abrir.setIcon(open);
	abrir.setSize(30,30);
	abrir.setToolTipText("Abre el selector de ficheros para elegir el fichero a abrir. Con 'ctrl' activado, borra lo que hay en la pantalla. (F)");
	abrir.setBackground(back);
	abrir.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_F();
		} 
	    }
			       );

	JButton savp = new JButton() ;
	savp = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	savp.setIcon(copy);
	savp.setSize(30,30);
	savp.setToolTipText("Abre un fichero Postscript (T)");
	savp.setBackground(back);
	savp.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_T();
		}
	    }
			       ) ;

	JButton tran = new JButton() ;
	tran = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	tran.setIcon(trans);
	tran.setSize(30,30);
	tran.setToolTipText("Elige la transformación deseada  (R)");
	tran.setBackground(back);
	tran.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_R();
		} 
	    }
			       );

	JButton paste = new JButton() ;
	paste = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	paste.setIcon(past);
	paste.setSize(30,30);
	paste.setToolTipText("Pega la imagen elegida (V)");
	paste.setBackground(back);
	paste.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_V();
		} 
	    }
			       );
       	lin = new JButton() ;
	lin = new DoubleBorderedButton(
	   new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	   new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	lin.setIcon(linea);
	lin.setSize(30,30);
	lin.setToolTipText("Dibuja una línea con uno o más segmentos");
	lin.setBackground(back);
	lin.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 1 ;
		    parent.newstatus(status) ;
		}
	    }
	    ) ;
	JButton rect = new JButton(rectan) ;
	rect = new DoubleBorderedButton(
           new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	   new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	rect.setIcon(rectan);
	rect.setSize(30,30);
	rect.setToolTipText("Genera un rectángulo");
	rect.setBackground(back);
	rect.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 2 ;
		    parent.newstatus(status) ;
		}
	    }
			       ) ;
	JButton coni = new JButton() ;
	coni = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	coni.setIcon(elipse);
	coni.setSize(30,30);
	coni.setToolTipText("Genera una elipse o un círculo con 'ctrl'");
	coni.setBackground(back);
	coni.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 3 ;
		    parent.newstatus(status) ;
		}
	    }
			       ) ;
	JButton poli = new JButton() ;
	poli = new DoubleBorderedButton(
	   new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	   new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	poli.setIcon(polyg);
	poli.setToolTipText("Genera un polígono");
	poli.setSize(30,30);
	poli.setBackground(back);
	poli.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 4 ;
		    parent.newstatus(status) ;
		}
	    }
			       ) ;
	JButton cur = new JButton() ;
	cur = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	cur.setIcon(spline);
	cur.setSize(30,30);
	cur.setToolTipText("Genera una curva de Bezier abierta o cerrada. Con 'ctrl' genera un NURBS de 4 puntos");
	cur.setBackground(back);
	cur.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 5 ;
		    parent.newstatus(status) ;
		} 
	    }
			      );
	
	JButton text = new JButton() ;
	text = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	text.setIcon(texto);
	text.setSize(30,30);
	text.setToolTipText("Coloca el texto en la pantalla (E)");
	text.setBackground(back);
	text.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_E();
		    status = 6 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );
   	JButton chofl = new JButton();
	chofl = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	chofl.setIcon(flecha);
	chofl.setSize(30,30);
	chofl.setToolTipText("Pinchar para elegir una flecha y volver a pinchar para colocarla");
	chofl.setBackground(back);
	chofl.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_P();
		} 
	    }
			       ); 
	JButton ghos = new JButton();
	ghos = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	ghos.setIcon(ghost);
	ghos.setSize(30,30);
	ghos.setToolTipText("Abre GhostView para ver el dibujo generado (K)");
	ghos.setBackground(back);
	ghos.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent ev) {
		    parent.K_K();
		status=0;
		parent.newstatus(status);
		} 
	    }
			       ); 
	JButton dob = new JButton();
	dob = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	dob.setIcon(doble);
	dob.setSize(30,30);
	dob.setToolTipText("Selecciona uno a uno los objetos existentes (Q)");
	dob.setBackground(back);
	dob.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_Q();
		} 
	    }
			       );    
	JButton pun = new JButton();
	pun = new DoubleBorderedButton(
	     new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	     new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	pun.setIcon(punto);
	pun.setSize(30,30);
	pun.setToolTipText("Genera un círculo convertible a una espiral");
	pun.setBackground(back);
	pun.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    status = 9 ;
		    parent.newstatus(status) ;
		}
	    }
			       );
	JButton sal = new JButton() ;
	sal = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	sal.setIcon(salida);
	sal.setSize(30,30);
	sal.setToolTipText("Cierra el programa; borra los ficheros intermedios y sale");
	sal.setBackground(back);
	sal.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		  try
		    {
		      Runtime.getRuntime().exec("/bin/bash scripts/sale");
		    }
		  catch(IOException e) {
		    try
		      {
			Runtime.getRuntime().exec("cmd.exe /c start scripts\\sale.bat");
		      }
		    catch(IOException e2) {
		      try
			{
			  Runtime.getRuntime().exec("start.exe scripts\\sale.bat");
			}
		      catch(IOException e3) {}	    
		    }
		  }
	System.exit(0);
		} 
	    }      );

	JButton cop = new JButton() ;
	cop =new DoubleBorderedButton(
	      new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	      new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	cop.setIcon(savep);
	cop.setSize(30,30);
	cop.setToolTipText("Guardar la figura al archivo elegido (W)");
	cop.setBackground(back);
	cop.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_W();
		} 
	    }
			       );

	JButton col = new JButton() ;
	col = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	col.setIcon(color);
	col.setSize(30,30);
	col.setToolTipText("Elige el color del contorno del objeto (A)");
	col.setBackground(back);
	col.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_A();
		} 
	    }
			       );

	JButton fil = new JButton() ;
	fil = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	fil.setIcon(fill);
	fil.setSize(30,30);
	fil.setToolTipText("LLena la figura del color elegido (L)");
	fil.setBackground(back);
	fil.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    parent.K_L(); 
		} 
	    }
			       );

	JButton meta = new JButton() ;
	meta = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	meta.setIcon(metac);
	meta.setSize(30,30);
	meta.setToolTipText("Genera una línea simple");
	meta.setBackground(back);
	meta.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    status = 11 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );

	JButton cir = new JButton() ;
	cir = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	cir.setIcon(circle);
	cir.setSize(30,30);
	cir.setToolTipText("Genera un rectángulo de esquinas redondeadas");
	cir.setBackground(back);
	cir.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    status = 13 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );
	JButton newcir = new JButton() ;
	newcir = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	newcir.setIcon(angl);
	newcir.setToolTipText("Genera un arco o un sector de círculo con 'ctrl'");
	newcir.setSize(30,30);
	newcir.setBackground(back);
	newcir.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    status = 7 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );

	JButton mas = new JButton() ;
	mas = new DoubleBorderedButton(
	      new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	      new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	mas.setIcon(mass);
	mas.setSize(30,30);
	mas.setToolTipText("Cambia el círculo a una espiral (M)");
	mas.setBackground(back);
	mas.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_M();
		} 
	    }
			      );

	JButton menos = new JButton() ;
	menos = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	menos.setIcon(menoss);
	menos.setSize(30,30);
	menos.setToolTipText("Genera un punto");
	menos.setBackground(back);
	menos.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    status = 14 ;
		    parent.newstatus(status) ;
		}
	    }
			       );

	JButton borra = new JButton() ;
	borra = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	borra.setIcon(borrar);
	borra.setSize(30,30);
	borra.setToolTipText("Vacía de color el objeto seleccionado  (B)");
	borra.setBackground(back);
	borra.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_B();
		} 
	    }
			       );

	JButton eli = new JButton() ;
	eli = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	eli.setIcon(elim);
	eli.setSize(30,30);
	eli.setToolTipText("Elimina los objetos seleccionados  (X)");
	eli.setBackground(back);
	eli.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_X();
		} 
	    }
			       );
	
	JButton agru = new JButton() ;
	agru = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	agru.setIcon(agrupa);
	agru.setSize(30,30);
	agru.setToolTipText("Agrupa (desagrupa con 'ctrl') los objetos seleccionados (G)");
	agru.setBackground(back);
	agru.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_G();
		} 
	    }
			       );

	/*	JButton des = new JButton() ;
	des = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	des.setIcon(desag);
	des.setSize(30,30);
	des.setToolTipText("Ungroupe Objects  (U)");
	des.setBackground(back);
	des.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_U();
		} 
	    }
	    );*/
	JButton kill = new JButton() ;
	kill = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	kill.setIcon(killp);
	kill.setSize(30,30);
	kill.setToolTipText("Borra todos los objetos de la pantalla");
	kill.setBackground(back);
	kill.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent evt) {
		    status = 12 ;
		    parent.newstatus(status) ;
		} 
	    }
			       );

	JButton coob = new JButton() ;
	coob = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	coob.setIcon(coobj);
	coob.setSize(30,30);
	coob.setToolTipText("Genera un clon del objeto seleccionado (C)");
	coob.setBackground(back);
	coob.addActionListener(new ActionListener(){ 
	public void actionPerformed(ActionEvent evt) {
	    parent.K_C();
		} 
	    }
			       );

	JButton mall = new JButton() ;
	mall = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	mall.setIcon(malla);
	mall.setSize(30,30);
	mall.setToolTipText("Cambia la malla de fondo  (O)");
	mall.setBackground(back);
	mall.addActionListener(new ActionListener(){ 
	public void actionPerformed(ActionEvent evt) {
	    parent.K_O();
		} 
	    }
			       );
		JButton rot = new JButton() ;
	rot = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	rot.setIcon(rota);
	rot.setSize(30,30);
	rot.setToolTipText("Selecciona todos los objetos existentes y los agrupa  (D)");
	rot.setBackground(back);
	rot.addActionListener(new ActionListener(){ 
	public void actionPerformed(ActionEvent evt) {
	    parent.K_D();
		} 
	    }
			       );
	JButton line = new JButton() ;
	line = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	line.setIcon(lInea);
	line.setSize(30,30);
	line.setToolTipText("Elige el tipo de línea (J)");
	line.setBackground(back);
	line.addActionListener(new ActionListener(){ 
	public void actionPerformed(ActionEvent evt) {
	    parent.K_J();
		} 
	    }
			       );
	JButton tex = new JButton() ;
	tex = new DoubleBorderedButton(
	    new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
	    new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	tex.setIcon(tEx);
	tex.setSize(30,30);
	tex.setToolTipText("Genera un 'eje de rotación' para su utilización con otros objetos  (H)");
	tex.setBackground(back);
	tex.addActionListener(new ActionListener(){ 
	public void actionPerformed(ActionEvent evt) {
	    parent.K_H();
		} 
	    }
			      );
	JButton espe = new JButton() ;
	espe = new DoubleBorderedButton(
					 new BevelBorder (BevelBorder.LOWERED, dgray, Color.white),
					 new BevelBorder (BevelBorder.RAISED, dgray, Color.white));
	espe.setIcon(especial);
	espe.setSize(30,30);
	espe.setToolTipText("Selecciona un tipo de fuente especial  (Z)");
	espe.setBackground(back);
	espe.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    parent.K_Z();
		} 
	    }
				);
	set = new JButton() ;
	set = new DoubleBorderedButton(
				       new BevelBorder (BevelBorder.LOWERED, Color.white, dgray),
				       new BevelBorder (BevelBorder.RAISED, Color.white, dgray));
	set.setToolTipText("Abre o cierra la botonadura para dibujo variacional");
	set.setIcon(rset);
	set.setSize(54,50);
	set.setBackground(dgray);
	set.addActionListener(new ActionListener(){ 
		public void actionPerformed(ActionEvent evt) {
		    if(mg2.cnx.isVisible()==false)mg2.cnx.setVisible(true);
		    else mg2.cnx.setVisible(false);
		} 
	    }
				);

	add(meta);//recta
	add(chofl);//flecha
       	add(lin);//polilinea
	add(rect);//rectangulo
	add(cir);//roundrect
	add(poli);//poligono
	add(mas);//espiral
	add(menos);//punto
	add(pun);//circulo
	add(coni);//ovalo
	add(cur);//bezier
	add(newcir);//arco
	add(spli);//beta_splines
	add(tran);//afinidad
	add(espe);//Letras
	add(tex);//eje
	add(text);//texto
	add(ghos);//gv
	add(dob);
	add(line);
	add(coob);
	add(mall);
	add(agru);
	//	add(des);
	add(rot);//agrupa todo
	add(borra);
	add(fil);
	add(col);
	add(eli);
	add(abrir);
	add(cop);
	add(savp);
	add(paste);
	add(kill);
	add(sal);
    }    
}



class DoubleBorderedButton extends JButton 
{
    public DoubleBorderedButton (final Border normal, final Border selected) 
    {
	setBorder (normal);
	addMouseListener (new MouseAdapter() 
	    {
		public void mousePressed (MouseEvent e) 
		{
		    setBorder (selected);
		}
		public void mouseReleased (MouseEvent e) 
		{
		    setBorder (normal);
		}
	    });
    }
}

